#include"reg52.h"
#include <intrins.h>
#include <absacc.h>
#include "delay.h"
#include"RA8875_subroutine.h"
#include "userdef.h"

//===== LCD Panel Size =====
//#define P480x272
#define P320x240
//#define P640x480

#define LCD_X_MAX 319
#define LCD_Y_MAX 239


#define DATA_BUS_H  P0
#define DATA_BUS  P1

#define _16BIT_  //ڷʽ16bitģʽ

sbit  RS=P2^4;
sbit  CS=P2^3;
sbit  _WR=P2^2;
sbit  _RD=P2^1;



sbit led=P2^0;
sbit MCU_RST=P2^5;
sbit wait=P3^3;

#define uchar      unsigned char
#define uint       unsigned int


//==============================================

#define XMIN 45	    
#define YMIN 78	    

#define XMAX 984	
#define YMAX 951	
  

//#define TP_XY_exchange 
#define TP_X_swap
//#deinfe TP_Y_swap

#define LCD_X_SIZE 800
#define LCD_Y_SIZE 480

#define Xa  183      
#define Ya	826	     

#define Xb  871 	
#define Yb	177	    

//==============================================

idata signed char OFFSET_X=0;   //Xq
idata signed char OFFSET_Y=0;   //Yq

idata uint LCD_X,LCD_Y;

idata uint LCD_X_temp,LCD_Y_temp;

idata uint ADC_value_X,ADC_value_Y;

idata uint X1,Y1,X2,Y2,X3,Y3,X4,Y4;

counter1=0;
counter2=0;

void MidValueCalculate(void)
{
	if (X2>X3)
	{
		if (X3>X4)
		{
			X1=X3;
		}	
		else
		{
			if (X2>X4)
			{
				X1=X4;
			}
			else	
			{
				X1=X2;
			}
		}		
	}			
	else
	{
		if (X3<X4)
		{ 
			X1=X3;
		}	
		else
		{
			if (X2<X4)
			{ 
				X1=X4;
			}
			else	
			{ 
				X1=X2; 
			}
		}	
	}
	
	if(Y2>Y3)
	{
		if (Y3>Y4)
		{
			Y1=Y3;
		}	
		else
		{
			if (Y2>Y4)
			{ 
				Y1=Y4;
			}
			else	
			{ 
				Y1=Y2;
			}
		}		
	}			
	else
	{
		if (Y3<Y4)
		{ 
			Y1=Y3;
		}	
		else
		{
			if (Y2<Y4)
			{ 
				Y1=Y4;
			}
			else	
			{ 
				Y1=Y2; 
			}
		}									
	}
   
   
	#ifdef TP_XY_exchange
	ADC_value_X = Y1;
	ADC_value_Y = X1;
	#else
	ADC_value_X = X1;
	ADC_value_Y = Y1;
	#endif
	
	
	#ifdef TP_X_swap
	ADC_value_X = 0x03ff-ADC_value_X;
	#endif
	
	#ifdef TP_Y_swap
	ADC_value_Y = 0x03ff-ADC_value_Y;
	#endif 
 }
 

uint Get_X_ADC_Value_10bit(void)
{
	uint temp,temp1;

	temp=0;
	temp|=ADC_X();
	temp1=(temp<<2);
	temp= temp1|((ADC_XY()&0x03));

	return temp;   
}


uint Get_Y_ADC_Value_10bit(void)
{
	uint temp,temp1;

	temp=0;
	temp|=ADC_Y();
	temp1=(temp<<2);
	temp=temp1|((ADC_XY()>>2)&0x03);

	return temp;   
}

uint Manual_Get_X_ADC_Value_10bit(void)
{
	uint temp ,temp1;

	TP_latch_X();//if manual mode
	Delay100us(2);//if manual mode
	temp=0;
	temp|=ADC_X();
	temp1=(temp<<2);
	temp= temp1|((ADC_XY()&0x03));

	return temp;  
}


uint Manual_Get_Y_ADC_Value_10bit(void)
{  
	uint temp,temp1;

	TP_latch_Y();//if manual mode
	Delay100us(2);//if manual mode
	temp=0;
	temp|=ADC_Y();
	temp1=(temp<<2);
	temp=temp1|((ADC_XY()>>2)&0x03);

	return temp;  
}


//================================================
//
//================================================

void Get_XY_Calibration(void)
{
	ulong ttemp;

	uint temp1;

	temp1 = ADC_value_X;

	if (temp1<(XMIN-OFFSET_X))
	{
		temp1=(XMIN-OFFSET_X);
	}

	if (temp1>(XMAX-OFFSET_X))
	{
		temp1=(XMAX-OFFSET_X);
	}


	ttemp = temp1-(XMIN-OFFSET_X);		 
	ttemp *= LCD_X_SIZE;
	ttemp /= (XMAX-XMIN);
	LCD_X = (uint)ttemp; 


	temp1 = ADC_value_Y;

	if (temp1<(YMIN-OFFSET_Y))
	{
		temp1=(YMIN-OFFSET_Y);
	}

	if (temp1>(YMAX-OFFSET_Y))
	{
		temp1=(YMAX-OFFSET_Y);
	}
	ttemp = temp1-(YMIN-OFFSET_Y);
	ttemp *= LCD_Y_SIZE;
	ttemp /= (YMAX-YMIN);
	LCD_Y = (uint)ttemp;
}

 //==============================================================================
//Subroutine:	Show Hex	
//==============================================================================
void Print_Hex(uchar buf)
{
	uchar temp;
	temp=buf;
	temp = (temp >>4) & 0x0F;
	if(temp < 0x0A)
	{
	temp |= 0x30;
	}
	else temp = temp + 0x37;
	RA8875_LCD_DataWrite(temp);
	Chk_Busy();

	temp=buf;
	temp = temp & 0x0F;
	if(temp < 0x0A)
	{
		temp |= 0x30;
	}
	else temp = temp + 0x37;
	RA8875_LCD_DataWrite(temp);
	Chk_Busy();
}

void Trace_XY_Vaule(void)
{	  
	uchar temp;
	uint temp1;

	temp1=ADC_value_X;
	temp=(ADC_value_X>>8);	  		
	Font_Coordinate(10,20);  
	Show_String("X=0x");
	Print_Hex(temp);		 
	temp=temp1;
	Print_Hex(temp);
	Chk_Busy();

	temp1=ADC_value_Y;
	temp=(ADC_value_Y>>8);
	Font_Coordinate(10, 90);  
	Show_String("Y=0x");
	Print_Hex(temp);			
	temp=temp1;
	Print_Hex(temp);
	Chk_Busy();
}


void Print_Decimal(uint buffer)
{
	uint temp,temp1;

	temp=buffer/100;
	temp1= buffer%100;

	temp|=0x30;
	RA8875_LCD_DataWrite(temp);
	Chk_Busy();

	temp=temp1/10;	
	temp|=0x30;
	RA8875_LCD_DataWrite(temp);
	Chk_Busy();

	temp=temp1%10;	
	temp|=0x30;
	RA8875_LCD_DataWrite(temp);
	Chk_Busy();
}	  

// TP controller application function

void Access_TP_coordinate(void)	//
{
	clear_TP_interrupt();
	Delay100us(2);  //delay after clear_TP_interrupt		 
	if(Touch_Status())
	{
		X2=Get_X_ADC_Value_10bit();
		Y2=Get_Y_ADC_Value_10bit();
		
		//TP_event_mode();//if manual mode
		
		clear_TP_interrupt(); 
		Delay100us(2);  //delay after clear_TP_interrupt	
		if(Touch_Status())
		{    
			X3=Get_X_ADC_Value_10bit();
			Y3=Get_Y_ADC_Value_10bit();
			
			clear_TP_interrupt();
			Delay100us(2);  //delay after clear_TP_interrupt	
			if(Touch_Status())
			{
				X4 =Get_X_ADC_Value_10bit();
				Y4 =Get_Y_ADC_Value_10bit();
				
				// TP_event_mode();//if manual mode
				
				MidValueCalculate();
				
				Get_XY_Calibration();			
			}	
			else 
			{
				ADC_value_X=0; ADC_value_Y=0;
				LCD_X=0;LCD_Y=0;
			}
		}
		else
		{
			ADC_value_X=0; ADC_value_Y=0;
			LCD_X=0;LCD_Y=0;		
		}
	} 
	else
	{
		ADC_value_X=0; ADC_value_Y=0;
		LCD_X=0;LCD_Y=0;
	}
}

void detect_touch(void)
{  
	uchar h;
	uint i,j,ii,jj;
	
	//===============Auto mode======================		
	LCD_X_temp = LCD_X;	
	LCD_Y_temp = LCD_Y; 	
	
	clear_TP_interrupt();
	
	Delay100us(2);  //delay after clear_TP_interrupt	 
	if(Touch_Status())
	{	
		if(counter1 ==0) 
		{
			counter1++;
			h=0;
			do
			{
			
				Access_TP_coordinate();
				i = LCD_X ;
				j = LCD_Y ;
				Access_TP_coordinate();
				ii = LCD_X ;
				jj = LCD_Y ;
				if((i==ii)&&(j==jj))h++;
			}
			while(h<1&&Touch_Status());
			
			LCD_X_temp = LCD_X;
			LCD_Y_temp = LCD_Y;
		}
		else		
		{
			Access_TP_coordinate();
			
			if((LCD_X >= (LCD_X_temp+8))|| (LCD_X <= (LCD_X_temp-8)))
			{
				LCD_X = LCD_X_temp;
				LCD_Y = LCD_Y_temp;
				counter2++;
			}
			else 
			{
				counter2 = 0;
			}
			if((LCD_Y >= (LCD_Y_temp+8))|| (LCD_Y <= (LCD_Y_temp-8)))
			{
				LCD_X = LCD_X_temp;
				LCD_Y = LCD_Y_temp;
			}			
			if(counter2>5)
			{
				counter1=0;
				counter2=0;
			}
		}
	}
	else
	{
		LCD_X=0;
		LCD_Y=0;
		counter1 = 0;	
	}
}

//---------------------------------------------------------------------
#ifdef _SPI_
//===========================================================================

/******************************************************************************
SPI_Delay()
******************************************************************************/
void SPI_Delay(void)
{
	unsigned char t;
	t=1;
	while(--t!=0);
}
/******************************************************************************
4W_SPI_Init()
******************************************************************************/
void SPI_Init(void)
{
	SCK = 1;	
	SDI = 1;
	SDO = 1;	
	ZCS = 1;
}

/******************************************************************************
4W_SPI_Write()
******************************************************************************/
void SPI_Write(unsigned char dat)
{
	unsigned char t = 8;
	do
	{
		SDI = (bit)(dat & 0x80);
		dat <<= 1;
		SCK = 0;	
		//SPI_Delay();
		SCK = 1;
		//SPI_Delay();
	
	} while ( --t != 0 );
	//SCK = 1;
	//SDI = 1;
}

/******************************************************************************
4W_SPI_Read()
******************************************************************************/
unsigned char SPI_Read()
{
	unsigned char dat;
	unsigned char t = 8;
	SDO = 1;	
	do
	{
		SCK = 0;	
		//SPI_Delay();
		dat <<= 1;
		if ( SDO ) dat++;
		SCK = 1;	
		//SPI_Delay();
	} while ( --t != 0 );
	return dat;
}
#endif

//*********4_wire_SPI****************************
void RA8875_LCD_CmdWrite(uchar cmd)
{	
	while(!wait);    //æ-2012-11-12  wait͵ƽʶæ
	
	CS = 0;
	RS = 1;
	DATA_BUS = cmd;				
	_WR = 0;
	_WR = 1;
	CS = 1;
	DATA_BUS = 0xff;	
	RS = 0;	
}

//----------4W_------------//
void RA8875_LCD_DataWrite(uchar Data)
{
	while(!wait);    
	CS = 0;
	RS = 0;
	DATA_BUS = Data;
	_WR = 0;	
	_WR = 1;
	CS = 1;						
	DATA_BUS = 0xff;  	
	RS = 1;	
}


void RA8875_LCD_16bitDataWrite(uint Data)	//ԭΪuint
{
	while(!wait);    	

	CS = 0;
	RS = 0;
	
	DATA_BUS_H = (uchar)(Data>>8);
	DATA_BUS = (uchar)Data;
	
	_WR = 0;	
	_WR = 1;
	CS = 1;						
	DATA_BUS = 0xff;  	
	RS = 1;	

}


//----------------------//
uchar RA8875_LCD_DataRead(void)
{	
	uchar Data;
	
	while(!wait);    
	_WR = 1;
	CS = 0;
	RS = 0;
	_RD = 0;
	Data = DATA_BUS;
	_RD = 1;
	CS = 1;
	RS = 1;	 	
	return Data;
}  
//-----------------------//
uchar RA8875_LCD_StatusRead(void)
{
	uchar Data;		
	CS = 0;					
	RS  = 1;					
	_WR = 1;					
	_RD = 0;					
	Data = DATA_BUS;
	_RD = 1;		
	CS = 1;
	DATA_BUS = 0xff;
	RS  = 0;	
	return Data;
}

void LCD_Reset(void)
{
	MCU_RST = 0;
	Delay1ms(1);
	MCU_RST = 1;
	Delay1ms(1);
	Chk_Busy();
}

 void RA8875_PLL_ini(void)
{

    RA8875_LCD_CmdWrite(0x88);
    Delay1us();      
    RA8875_LCD_DataWrite(0x06);
    Delay1ms(1);     
    RA8875_LCD_CmdWrite(0x89);
    Delay1us();         
    RA8875_LCD_DataWrite(0x01);  
    Delay1ms(1);
	RA8875_LCD_CmdWrite(0x01);
    Delay1us();         
    RA8875_LCD_DataWrite(0x01);  
    Delay1ms(1);
	RA8875_LCD_DataWrite(0x00);  
    Delay1ms(1);

}


void LCD_Initial(void)
{ 	



	RA8875_PLL_ini();
	RA8875_LCD_CmdWrite(0x10);  //SYSR   bit[4:3]=00 256 color  bit[2:1]=  00 8bit MPU interface
	RA8875_LCD_DataWrite(0x0e); //16bit

    RA8875_LCD_CmdWrite(0x11);    //set PCLK invers
    RA8875_LCD_DataWrite(0x00); 
    Delay1ms(1);
	RA8875_LCD_CmdWrite(0x12);    //set PCLK invers
    RA8875_LCD_DataWrite(0x00);
	Delay1ms(1);
	RA8875_LCD_CmdWrite(0x13);    //set PCLK invers
    RA8875_LCD_DataWrite(0x05);
    //Horizontal set
    RA8875_LCD_CmdWrite(0x14);	   //HDWR//Horizontal Display Width Setting Bit[6:0] 
    RA8875_LCD_DataWrite(0x27);   //Horizontal display width(pixels) = (HDWR + 1)*8 	
    RA8875_LCD_CmdWrite(0x15);    //
    RA8875_LCD_DataWrite(0x84);   //
    RA8875_LCD_CmdWrite(0x16);	   //HNDR//Horizontal Non-Display Period Bit[4:0] 
    RA8875_LCD_DataWrite(0x03);   //Horizontal Non-Display Period (pixels) = (HNDR + 1)*8 
    RA8875_LCD_CmdWrite(0x17);	   //HSTR//HSYNC Start Position[4:0] 
    RA8875_LCD_DataWrite(0x02);   //HSYNC Start Position(PCLK) = (HSTR + 1)*8 
    RA8875_LCD_CmdWrite(0x18);	   //HPWR//HSYNC Polarity ,The period width of HSYNC. 
    RA8875_LCD_DataWrite(0x03);   //HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8 

    //Vertical set
    RA8875_LCD_CmdWrite(0x19);    //VDHR0 //Vertical Display Height Bit [7:0] 
    RA8875_LCD_DataWrite(0xef);   //Vertical pixels = VDHR + 1
    RA8875_LCD_CmdWrite(0x1a);    //VDHR1 //Vertical Display Height Bit [8] 
    RA8875_LCD_DataWrite(0x00);   //Vertical pixels = VDHR + 1 	
    RA8875_LCD_CmdWrite(0x1b);    //VNDR0 //Vertical Non-Display Period Bit [7:0]
    RA8875_LCD_DataWrite(0x0a);   //Vertical Non-Display area = (VNDR + 1) 	
    RA8875_LCD_CmdWrite(0x1c);    //VNDR1 //Vertical Non-Display Period Bit [8] 
    RA8875_LCD_DataWrite(0x00);   //Vertical Non-Display area = (VNDR + 1) 	
    RA8875_LCD_CmdWrite(0x1d);    //VSTR0 //VSYNC Start Position[7:0]
    RA8875_LCD_DataWrite(0x0e);   //VSYNC Start Position(PCLK) = (VSTR + 1) 
    RA8875_LCD_CmdWrite(0x1e);    //VSTR1 //VSYNC Start Position[8] 
    RA8875_LCD_DataWrite(0x06);   //VSYNC Start Position(PCLK) = (VSTR + 1) 	
    RA8875_LCD_CmdWrite(0x1f);    //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]
    RA8875_LCD_DataWrite(0x01);   //VSYNC Pulse Width(PCLK) = (VPWR + 1) 


	//ɨ跽
	RA8875_LCD_CmdWrite(0x28);     
	RA8875_LCD_DataWrite(0x04); 
}

//ʼ
//һҪLCD_Reset();֮
void BackLight_PWM_8875(uchar level)
{
	PWM1_enable();
	PWM1_fnuction_sel();
	PWM1_clock_ratio(0x04); //bit0~3 
	PWM1_duty_cycle(level);  
}

void main(void)
{  
 	uchar i;
	uchar j;
	uint p;
	led = 0;//ر
	Delay100ms(2);        												//ϵʱ
	LCD_Reset(); 


	led = 1;//
	LCD_Initial();


   	BackLight_PWM_8875(100);    									//ڱ


	Active_Window(0,LCD_X_MAX,0,LCD_Y_MAX);      	//趨ʾ
	Clear_Active_Window();                      	//崰

	Text_Foreground_Color(0x00,0x00,0x00);        //ǰɫ
	Text_Background_Color(0x00,0x00,0x00);        //豳ɫ
	Memory_Clear();	                              //
	Display_ON();                                 //ʾ
	Chk_Busy();                                   //æ	
	XY_Coordinate(0,0);                           //ʾ
	Graphic_Mode();
	for(p=0;p<32;p++)
	{
		Active_Window(p*2,p*2+1,0,239);      	//趨ʾ
		RA8875_LCD_CmdWrite(0x02);                    //ָڴд
		for(i=0;i<2;i++)
		for(j=0;j<240;j++)                            //
		{
			RA8875_LCD_16bitDataWrite(p);		  //16λ
			Chk_Busy();
		}
	}

	for(p=0;p<64;p++)
	{
		Active_Window(64+p*1,64+p*1+1,0,239);      	//趨ʾ
		RA8875_LCD_CmdWrite(0x02);                    //ָڴд
		for(i=0;i<2;i++)
		for(j=0;j<240;j++)                            //
		{
			RA8875_LCD_16bitDataWrite(p*32);		  //16λ
			Chk_Busy(); 								//æ
		}
	}
		                               
	for(p=0;p<32;p++)
	{
		Active_Window(129+p*2,129+p*2+1,0,239);      	//趨ʾ
		RA8875_LCD_CmdWrite(0x02);                    //ָڴд
		for(i=0;i<2;i++)
		for(j=0;j<240;j++)                            //
		{
			RA8875_LCD_16bitDataWrite(p*2048);		  //16λ
			Chk_Busy(); 								//æ
		}                                  //æ
    }

	for(p=0;p<31;p++)					   
	{
		Active_Window(193+p*4,193+p*4+3,0,239);         	//趨ʾ
		Clear_Active_Window();                      	//崰
		Text_Background_Color(p,p*2,p);        //豳ɫ
		Memory_Clear();	                              //
		Display_ON();                                 //ʾ
		Chk_Busy();                                   //æ
    }
	Delay100ms(5);


   	 	 //============================
	 //ʾ8*16 dots ASCII ʾ
	 //============================
    Text_Mode();
	ASCII_Mode_enable();
	Text_Foreground_Color(0x03);//ɫ
    Text_Background_Color(0xff);//ɫ
    Active_Window(109,319,0,239);	
	XY_Coordinate(109,0);
	LCD_CmdWrite(0x02);
	for(i=0;i<256;i++)
	{
	 LCD_DataWrite(i);
     Chk_Busy();
	 }
	 //============================
	 //ʾ8*16 dots ASCII ʾ
	 //============================
    Text_Mode();
	ASCII_Mode_enable();
	Text_Foreground_Color(0x03);//ɫ
    Text_Background_Color(0xff);//ɫ
    Active_Window(109,319,0,239);	
	XY_Coordinate(109,0);
	LCD_CmdWrite(0x02);
	for(i=0;i<256;i++)
	{
	 LCD_DataWrite(i);
     Chk_Busy();
	 }

	 //==================================
	 //ʾ16*16 dots ʾ
	 //==================================
	ASCII_Mode_disable();
   	External_CGROM();
	//ʾ
    External_CGROM_GB();
	Active_Window(5,108,105,239);	
    XY_Coordinate(5,125); 
	Text_Foreground_Color(0xe0);//ɫ
	Show_String("");

	while(1);
}



bit Touch_Status(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0xF1);//INTC	
	temp = RA8875_LCD_DataRead();
	if ((temp&0x04)==0x04)
	return 1;
	else 
	return 0;
}

void clear_TP_interrupt(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF1);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp |= cSetD2;
  RA8875_LCD_DataWrite(temp);
 }


//********************************************************

				
//------------------------//
//STATUS 
void Chk_Busy(void)
{
	uchar temp; 	
	do
	{
	temp=RA8875_LCD_StatusRead();
	}while((temp&0x80)==0x80);
	
}
void Chk_Busy_BTE(void)
{
	uchar temp;
   	
	do
	{
     temp=LCD_StatusRead();
	}while((temp&0x40)==0x40);	   
}

void Chk_Busy_DIR_Access(void)
{
	uchar  temp;
   	
	do
	{
     temp=RA8875_LCD_StatusRead();
	}while((temp&0x01)==0x01);	   
}

//REG[BFh]
void Chk_DMA_Busy(void)
{
	uchar temp; 	
	do
	{
	RA8875_LCD_CmdWrite(0xBF);
	temp = RA8875_LCD_DataRead();
	}while((temp&0x01)==0x01);   
}
//---------------------------//
//REG[01h]		 

void Display_ON(void)
{	
	uchar temp;
	RA8875_LCD_CmdWrite(0x01);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7;
	//RA8875_LCD_DataWrite(temp);
	RA8875_LCD_DataWrite(cSetD7);
	temp = RA8875_LCD_DataRead();
	
}

void Display_OFF(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x01);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7;
	RA8875_LCD_DataWrite(temp);
}

void Normal_Mode_exitSleep(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x01);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1;
	RA8875_LCD_DataWrite(temp);
}
void Sleep_Mode(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x01);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD1;
	RA8875_LCD_DataWrite(temp);
}
void Software_Reset(void)
{	
	RA8875_LCD_CmdWrite(0x01);//PWRR
	RA8875_LCD_DataWrite(0x01);
	RA8875_LCD_DataWrite(0x00);
	Delay1ms(1);// 
}							   
//-------------------------------//
//REG[04h] for test 
void PCLK_inversion(void)
{ 	
	uchar temp;
  RA8875_LCD_CmdWrite(0x04);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7;
	RA8875_LCD_DataWrite(temp);
}
void PCLK_non_inversion(void)
{ 	
	uchar temp;
  RA8875_LCD_CmdWrite(0x04);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7;
	RA8875_LCD_DataWrite(temp);
}

void PCLK_width(uchar setx) //bit[1:0]
{ 	
	uchar temp;
  RA8875_LCD_CmdWrite(0x04);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0x80;
  temp |= setx;
	RA8875_LCD_DataWrite(temp);
}

//-------------------------------//
//REG[05h]
void Serial_ROM_select0(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=cClrD7;
	RA8875_LCD_DataWrite(temp);
}

void Serial_ROM_select1(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |=cSetD7;
	RA8875_LCD_DataWrite(temp);
}

void Serial_ROM_Address_set_24bit(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=cClrD6;
	RA8875_LCD_DataWrite(temp);
}

void Serial_ROM_Address_set_32bit(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |=cSetD6;
	RA8875_LCD_DataWrite(temp);
}

void Select_Serial_Waveform_mode0(void)
{	
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=cClrD5;
	RA8875_LCD_DataWrite(temp);
}

void Select_Serial_Waveform_mode3(void)
{	
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |=cSetD5;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Read_Cycle_4bus(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0xE7;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Read_Cycle_5bus(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0xE7;
  temp |=cSetD3;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Read_Cycle_6bus(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0xE7;
  temp |=cSetD4;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Font_mode(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=cClrD2;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_DMA_mode(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp |=cSetD2;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Signal_mode(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0xFC;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Dual_mode0(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0xFC;
    temp |=cSetD1;
	RA8875_LCD_DataWrite(temp);
}

void SERIAL_ROM_Dual_mode1(void)
{   
	uchar temp;
  RA8875_LCD_CmdWrite(0x05);//PWRR
	temp = RA8875_LCD_DataRead();
	temp &=0xFC;
  temp |=cSetD1;
  temp |=cSetD0;
	RA8875_LCD_DataWrite(temp);
}

void SROM_CLK_DIV(uchar CLK_DIV)
{
	RA8875_LCD_CmdWrite(0x06);
  RA8875_LCD_DataWrite(CLK_DIV);
}


//-------------------------------//
//REG[10h]
void Color_256(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x10);//SYSR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	RA8875_LCD_DataWrite(temp);
} 

void Color_65K(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x10);//SYSR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cSetD3ClrD2 ;
	RA8875_LCD_CmdWrite(0x10);//SYSR
	RA8875_LCD_DataWrite(temp);
}
void MPU_8bit_Interface(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x10);//SYSR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	RA8875_LCD_DataWrite(temp);
}

void MPU_16bit_Interface(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x10);//SYSR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD1ClrD0 ;
	RA8875_LCD_DataWrite(temp);
} 								 
//--------------------------------//
//REG[12h] 

uchar GPI_data(void)
{   
	uchar temp;
	RA8875_LCD_CmdWrite(0x12);//SYSR
	temp = RA8875_LCD_DataRead();
	return temp;
}

void GPO_data(uchar setx)
{
  RA8875_LCD_CmdWrite(0x13); 
  RA8875_LCD_DataWrite(setx);
}

							
//---------------------------------//
//REG[20h]

void One_Layer(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x20);//DPCR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}	
				 
void Two_Layers(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x20);//DPCR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);
}

void HDIR_SEG0_SEGn(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x20);//DPCR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3 ;
	RA8875_LCD_DataWrite(temp);
}
void HDIR_SEGn_SEG0(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x20);//DPCR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD3 ;
	RA8875_LCD_DataWrite(temp);
}
void VDIR_COM0_COMn(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x20);//DPCR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD2 ;
	RA8875_LCD_DataWrite(temp);
}
void VDIR_COMn_COM0(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x20);//DPCR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD2 ;
	RA8875_LCD_DataWrite(temp);
}


//----------------------------------//
//REG[21h] 
void CGROM_Font(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}
void CGRAM_Font(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Internal_CGROM(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD5 ;
	RA8875_LCD_DataWrite(temp);
}
void External_CGROM(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD5 ;
	RA8875_LCD_DataWrite(temp);
}

void ISO8859_1(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	RA8875_LCD_DataWrite(temp);
}
void ISO8859_2(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	temp |= cClrD1SetD0 ;
	RA8875_LCD_DataWrite(temp);
}
void ISO8859_3(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	temp |= cSetD1ClrD0 ;
	RA8875_LCD_DataWrite(temp);
}
void ISO8859_4(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x21);//FNCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	temp |= cSetD1D0 ;
	RA8875_LCD_DataWrite(temp);
}								 
//--------------------------------//
//REG[22h]

void No_FullAlignment(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}
void FullAlignment(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);
}
void Font_with_BackgroundColor(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6 ;
	RA8875_LCD_DataWrite(temp);
}
void Font_with_BackgroundTransparency(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6 ;
	RA8875_LCD_DataWrite(temp);
}


void NoRotate_Font(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD4 ;
	RA8875_LCD_DataWrite(temp);
}
void Rotate90_Font(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD4 ;
	RA8875_LCD_DataWrite(temp);
}


void Horizontal_FontEnlarge_x1(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	RA8875_LCD_DataWrite(temp);
}
void Horizontal_FontEnlarge_x2(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cClrD3SetD2 ;
	RA8875_LCD_DataWrite(temp);
}
void Horizontal_FontEnlarge_x3(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cSetD3ClrD2 ;
	RA8875_LCD_DataWrite(temp);
}
void Horizontal_FontEnlarge_x4(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cSetD3D2 ;
	RA8875_LCD_DataWrite(temp);
}
void Vertical_FontEnlarge_x1(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	RA8875_LCD_DataWrite(temp);
}
void Vertical_FontEnlarge_x2(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	temp |= cClrD1SetD0 ;
	RA8875_LCD_DataWrite(temp);
}
void Vertical_FontEnlarge_x3(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	temp |= cSetD1ClrD0 ;
	RA8875_LCD_DataWrite(temp);
}
void Vertical_FontEnlarge_x4(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x22);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0 ;
	temp |= cSetD1D0 ;
	RA8875_LCD_DataWrite(temp);
}

//-------------------------------------------//
//REG[23h]									 
void CGRAM_Select_Number(uchar setx)
{ 
		RA8875_LCD_CmdWrite(0x23);//CGSR
		RA8875_LCD_DataWrite(setx);
}	
								
//-------------------------------------------//
//REG[24h]REG[25h]REG[26h]REG[27h]
void Scroll_Offset(uint X,uint Y)
{
		uchar temp;

		temp=X;   
		RA8875_LCD_CmdWrite(0x24);//HOFS0
		RA8875_LCD_DataWrite(temp);
		temp=X>>8;   
		RA8875_LCD_CmdWrite(0x25);//HOFS1	   
		RA8875_LCD_DataWrite(temp);

		temp=Y;   
		RA8875_LCD_CmdWrite(0x26);//VOFS0
		RA8875_LCD_DataWrite(temp);
		temp=Y>>8;   
		RA8875_LCD_CmdWrite(0x27);//VOFS1	   
		RA8875_LCD_DataWrite(temp); 
}	 
//-------------------------------------------//
//REG[29h]
void Line_distance(uchar setx)
{ 
		RA8875_LCD_CmdWrite(0x29);//LDS
		RA8875_LCD_DataWrite(setx);
}	  
//-------------------------------------------//
//REG[2Ah]REG[2Bh]REG[2Ch]REG[2Dh]
void Font_Coordinate(uint X,uint Y)
{
		uchar temp;   
		temp=X;   
		RA8875_LCD_CmdWrite(0x2A);//HOFS0
		RA8875_LCD_DataWrite(temp);
		temp=X>>8;   
		RA8875_LCD_CmdWrite(0x2B);//HOFS1	   
		RA8875_LCD_DataWrite(temp);

		temp=Y;   
		RA8875_LCD_CmdWrite(0x2C);//VOFS0
		RA8875_LCD_DataWrite(temp);
		temp=Y>>8;   
		RA8875_LCD_CmdWrite(0x2D);//VOFS1	   
		RA8875_LCD_DataWrite(temp); 
}


//-------------------------------------------//
//REG[2Eh]
void Font_size_16x16_8x16(void) 
{
 	uchar temp;
	RA8875_LCD_CmdWrite(0x2E);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0x3f;
	RA8875_LCD_DataWrite(temp);
}

void Font_size_24x24_12x24(void) 
{
 	uchar temp;
	RA8875_LCD_CmdWrite(0x2E);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0x3f;
	temp |= 0x40; 
	RA8875_LCD_DataWrite(temp);
}

void Font_size_32x32_16x32(void) 
{
 	uchar temp;
	RA8875_LCD_CmdWrite(0x2E);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0x3f;
	temp |= 0x80; 
	RA8875_LCD_DataWrite(temp);
}


void Font_spacing_set(uchar setx) //bit[5:0]
{   
	uchar temp,temp1;
	temp1=setx&0x3F;
	RA8875_LCD_CmdWrite(0x2E);//FNCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0xc0;
	temp |= temp1; 
	RA8875_LCD_DataWrite(temp);

}

//-------------------------------------------//
//REG[2Fh]
void GT_serial_ROM_select_GT21L16T1W(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0x1f;
  RA8875_LCD_DataWrite(temp);
}

void GT_serial_ROM_select_GT23L16U2W(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0x1f;
  temp |= 0x20;
  RA8875_LCD_DataWrite(temp);
}

void GT_serial_ROM_select_GT23L24T3Y(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0x1f;
  temp |= 0x40;
  RA8875_LCD_DataWrite(temp);
}

void GT_serial_ROM_select_GT23L24M1Z(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0x1f;
  temp |= 0x60;
  RA8875_LCD_DataWrite(temp);
}

void GT_serial_ROM_select_GT23L32S4W(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0x1f;
  temp |= 0x80;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_GB2312(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_GB12345(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
   temp |= 0x04;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_BIG5(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  temp |= 0x08;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_UNICODE(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  temp |= 0x0C;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_ASCII(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  temp |= 0x10;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_UNIJIS(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  temp |= 0x14;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_JIS0208(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  temp |= 0x18;
  RA8875_LCD_DataWrite(temp);
}

void Font_code_LATIN(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xE3;
  temp |= 0x1C;
  RA8875_LCD_DataWrite(temp);
}

void Font_Standard(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xFC;
  RA8875_LCD_DataWrite(temp);
}

void Font_Arial(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xFC;
  temp |= 0x01;
  RA8875_LCD_DataWrite(temp);
}

void Font_Roman(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= 0xFC;
  temp |= 0x02;
  RA8875_LCD_DataWrite(temp);
}

void Font_Bold(void) //for ASCII
{ uchar temp;
  RA8875_LCD_CmdWrite(0x2F);//FNCR1
  temp = RA8875_LCD_DataRead();
  temp &= cClrD1D0;
  temp |= cSetD1D0;
  RA8875_LCD_DataWrite(temp);
}

//-------------------------------------------//
//REG[30h]~REG[37h]
void Active_Window(uint XL,uint XR ,uint YT ,uint YB)
{
		uchar temp;
		//setting active window X
		temp=XL;   
		RA8875_LCD_CmdWrite(0x30);//HSAW0
		RA8875_LCD_DataWrite(temp);
		temp=XL>>8;   
		RA8875_LCD_CmdWrite(0x31);//HSAW1	   
		RA8875_LCD_DataWrite(temp);

		temp=XR;   
		RA8875_LCD_CmdWrite(0x34);//HEAW0
		RA8875_LCD_DataWrite(temp);
		temp=XR>>8;   
		RA8875_LCD_CmdWrite(0x35);//HEAW1	   
		RA8875_LCD_DataWrite(temp);

		//setting active window Y
		temp=YT;   
		RA8875_LCD_CmdWrite(0x32);//VSAW0
		RA8875_LCD_DataWrite(temp);
		temp=YT>>8;   
		RA8875_LCD_CmdWrite(0x33);//VSAW1	   
		RA8875_LCD_DataWrite(temp);

		temp=YB;   
		RA8875_LCD_CmdWrite(0x36);//VEAW0
		RA8875_LCD_DataWrite(temp);
		temp=YB>>8;   
		RA8875_LCD_CmdWrite(0x37);//VEAW1	   
		RA8875_LCD_DataWrite(temp);
}
//--------------------------------------------//
//REG[38h]~REG[3Fh]

void Scroll_Window(uint XL,uint XR ,uint YT ,uint YB)
{
		uchar temp;

		temp=XL;   
		RA8875_LCD_CmdWrite(0x38);//HSSW0
		RA8875_LCD_DataWrite(temp);
		temp=XL>>8;   
		RA8875_LCD_CmdWrite(0x39);//HSSW1	   
		RA8875_LCD_DataWrite(temp);

		temp=XR;   
		RA8875_LCD_CmdWrite(0x3c);//HESW0
		RA8875_LCD_DataWrite(temp);
		temp=XR>>8;   
		RA8875_LCD_CmdWrite(0x3d);//HESW1	   
		RA8875_LCD_DataWrite(temp);   

		temp=YT;   
		RA8875_LCD_CmdWrite(0x3a);//VSSW0
		RA8875_LCD_DataWrite(temp);
		temp=YT>>8;   
		RA8875_LCD_CmdWrite(0x3b);//VSSW1	   
		RA8875_LCD_DataWrite(temp);

		temp=YB;   
		RA8875_LCD_CmdWrite(0x3e);//VESW0
		RA8875_LCD_DataWrite(temp);
		temp=YB>>8;   
		RA8875_LCD_CmdWrite(0x3f);//VESW1	   
		RA8875_LCD_DataWrite(temp);
}  


//--------------------------------------------//
//REG[40h]
void Graphic_Mode(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Text_Mode(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);	 
} 

void Text_Cursor_Disable(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6 ;
	RA8875_LCD_DataWrite(temp);
}

void Text_Cursor_Enable(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6 ;
	RA8875_LCD_DataWrite(temp);	 	
} 

void Text_Cursor_Blink_Disable(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD5 ;
	RA8875_LCD_DataWrite(temp);
}

void Text_Cursor_Blink_Enable(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD5 ;
	RA8875_LCD_DataWrite(temp);
}

void Memory_Write_LeftRight_TopDown(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	RA8875_LCD_DataWrite(temp);
}

void Memory_Write_RightLeft_TopDown(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cClrD3SetD2 ;
	RA8875_LCD_DataWrite(temp);
}

void Memory_Write_DownTop_LeftRight(void)
{	uchar temp;	
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cSetD3D2 ;
	RA8875_LCD_DataWrite(temp);
}

void Memory_Write_TopDown_LeftRight(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	temp |= cSetD3ClrD2 ;
	RA8875_LCD_DataWrite(temp);
} 

void MemoryWrite_Cursor_autoIncrease(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1 ;
	RA8875_LCD_DataWrite(temp);
}

void MemoryWrite_Cursor_NoautoIncrease(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD1 ;
	RA8875_LCD_DataWrite(temp);
}

void MemoryRead_Cursor_autoIncrease(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD0 ;
	RA8875_LCD_DataWrite(temp);
}

void MemoryRead_Cursor_NoautoIncrease(void)
{
	uchar temp;

	RA8875_LCD_CmdWrite(0x40);//MWCR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD0 ;
	RA8875_LCD_DataWrite(temp);
}  										 

//--------------------------------------------//
//REG[41h]
void No_Graphic_Cursor(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set1(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set2(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cClrD6D5SetD4 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set3(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cClrD6SetD5ClrD4 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set4(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cClrD6SetD5D4 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set5(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cSetD6ClrD5D4 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set6(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cSetD6ClrD5SetD4 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set7(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cSetD6D5ClrD4 ;
	RA8875_LCD_DataWrite(temp);
}

void Graphic_Cursor_Set8(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6D5D4 ;
	temp |= cSetD6D5D4 ;
	RA8875_LCD_DataWrite(temp);
}

void Write_To_Bank1and2(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3D2 ;
	RA8875_LCD_DataWrite(temp);
}

void Write_To_CGRAM(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0xf3;
	temp |= cClrD3SetD2 ;
	RA8875_LCD_DataWrite(temp);
}

void Write_To_GraphicCursor(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0xf3;
	temp |= cSetD3ClrD2 ;
	RA8875_LCD_DataWrite(temp);
}

void Write_To_Pattern(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= 0xf3;
	temp |= cSetD3D2 ;
	RA8875_LCD_DataWrite(temp);
}
						   
void Write_To_Bank1(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD0 ;
	RA8875_LCD_DataWrite(temp);
}

void Write_To_Bank2(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x41);//MWCR1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD0 ;
	RA8875_LCD_DataWrite(temp);  
}	
							
//--------------------------------------------//

//--------------------------------------------//
//REG[44h]
void Text_Blink_Time(uchar setx)
{	
	RA8875_LCD_CmdWrite(0x44);//CURS
	RA8875_LCD_DataWrite(setx);
}

//--------------------------------------------//
//REG[45h]  
void Memory_read_LeftRight_TopDown(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x45);//MRCD
	temp = RA8875_LCD_DataRead();
	temp &= cClrD1D0;
	RA8875_LCD_DataWrite(temp);
}
void Memory_read_RightLeft_TopDown(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x45);//MRCD
	temp = RA8875_LCD_DataRead();
	temp |= cClrD1SetD0;
	RA8875_LCD_DataWrite(temp);
}
void Memory_read_TopDown_LeftRight(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x45);//MRCD
	temp = RA8875_LCD_DataRead();
	temp |= cSetD1ClrD0;
	RA8875_LCD_DataWrite(temp);
}
void Memory_read_DownTop_LeftRight(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x45);//MRCD
	temp = RA8875_LCD_DataRead();
	temp |= cSetD1D0;
	RA8875_LCD_DataWrite(temp);
}			

//--------------------------------------------//
//REG[46h]~REG[49h]
void XY_Coordinate(uint X,uint Y)
{	
	uchar temp;
	temp=X;   
	RA8875_LCD_CmdWrite(0x46);
	RA8875_LCD_DataWrite(temp);
	temp=X>>8;   
	RA8875_LCD_CmdWrite(0x47);	   
	RA8875_LCD_DataWrite(temp);

	temp=Y;   
	RA8875_LCD_CmdWrite(0x48);
	RA8875_LCD_DataWrite(temp);
	temp=Y>>8;   
	RA8875_LCD_CmdWrite(0x49);	   
	RA8875_LCD_DataWrite(temp);
}



//--------------------------------------------//
//REG[4Ah]~REG[4Dh]
void Memory_read_Coordinate(uint X,uint Y)
{
		uchar temp;

		temp=X;   
		RA8875_LCD_CmdWrite(0x4a);
		RA8875_LCD_DataWrite(temp);
		temp=X>>8;   
		RA8875_LCD_CmdWrite(0x4b);	   
		RA8875_LCD_DataWrite(temp);

		temp=Y;   
		RA8875_LCD_CmdWrite(0x4c);
		RA8875_LCD_DataWrite(temp);
		temp=Y>>8;   
		RA8875_LCD_CmdWrite(0x4d);	   
		RA8875_LCD_DataWrite(temp);
} 
						  
//--------------------------------------------//
//REG[4Eh]
void Text_Cursor_Horizontal_Size(uchar setx)//bit[3:0]
{
		RA8875_LCD_CmdWrite(0x4E);//CURS	   
		RA8875_LCD_DataWrite(setx);
} 
								
//REG[4Fh] 
void Text_Cursor_Vertical_Size(uchar setx)//bit[3:0]
{
		RA8875_LCD_CmdWrite(0x4F);//CURS	   
		RA8875_LCD_DataWrite(setx);
} 	
	
//--------------------------------------------//
//REG[50h] 
void no_BTE_write(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x50);//BECR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);  
}

void BTE_enable(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x50);//BECR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);  
}

void BTE_contiguous_Data(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x50);//BECR0
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6 ;
	RA8875_LCD_DataWrite(temp);  
}

void BTE_rectangular_Data(void)
{	uchar temp;												   
	RA8875_LCD_CmdWrite(0x50);//BECR0
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6 ;
	RA8875_LCD_DataWrite(temp);  
}									  

//---------------------------------------------//
//REG[51h] 
void BTE_ROP_Code(uchar setx)
{	 
	RA8875_LCD_CmdWrite(0x51);//BECR1	   
	RA8875_LCD_DataWrite(setx); 
}									   

//---------------------------------------------//
//REG[52h] 
void Layer1_Visible(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	RA8875_LCD_DataWrite(temp);  
}

void Layer2_Visible(void)
{   uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	temp|=0x01;
	RA8875_LCD_DataWrite(temp);  
}	
						
void Transparent_Mode(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	temp|=0x03;
	RA8875_LCD_DataWrite(temp);  
}

void Lighten_Overlay_Mode(void)
{   
	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	temp|=0x02;
	RA8875_LCD_DataWrite(temp);  
}	
						
void Boolean_OR(void)
{   
	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	temp|=0x04;
	RA8875_LCD_DataWrite(temp);
}

void Boolean_AND(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	temp|=0x05;
	RA8875_LCD_DataWrite(temp);  
}  	 
	
  
void Floating_window_mode(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0xf8;
	temp|=0x06;
	RA8875_LCD_DataWrite(temp);  
} 

void Floating_Window_transparent_with_BGTR_enable(void)
{   
	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp|=cSetD5;
	RA8875_LCD_DataWrite(temp);  
}

void Floating_Window_transparent_with_BGTR_disable(void)
{   
	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=cClrD5;
	RA8875_LCD_DataWrite(temp);  
}


void Layer1_2_scroll(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0x3f;
	RA8875_LCD_DataWrite(temp);  
}  	 

void Layer1_scroll(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0x3f;
	temp|=0x40;
	RA8875_LCD_DataWrite(temp);  
} 

void Layer2_scroll(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0x3f;
	temp|=0x80;
	RA8875_LCD_DataWrite(temp);  
} 

void Buffer_scroll(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x52);//LTPR0
	temp = RA8875_LCD_DataRead();
	temp&=0x3f;
	temp|=0xC0;
	RA8875_LCD_DataWrite(temp);  
} 

//---------------------------------------------//
//REG[53h] 
void layer2_1_transparency(uchar setx)
{  
   RA8875_LCD_CmdWrite(0x53);//LTPR1
   RA8875_LCD_DataWrite(setx); 
}

//---------------------------------------------//
//REG[54h]~ [5Fh]
void BTE_Source_Destination	(uint XL,uint XR ,uint YT ,uint YB)
{
	uchar temp,temp1;

	temp=XL;   
	RA8875_LCD_CmdWrite(0x54);//HSBE0
	RA8875_LCD_DataWrite(temp);
	temp=XL>>8;   
	RA8875_LCD_CmdWrite(0x55);//HSBE1	   
	RA8875_LCD_DataWrite(temp);

	temp=XR;   
	RA8875_LCD_CmdWrite(0x58);//HDBE0
	RA8875_LCD_DataWrite(temp);
	temp=XR>>8;   
	RA8875_LCD_CmdWrite(0x59);//HDBE1	   
	RA8875_LCD_DataWrite(temp); 

	temp=YT;   
	RA8875_LCD_CmdWrite(0x56);//VSBE0
	RA8875_LCD_DataWrite(temp);
	temp=YT>>8;   
	RA8875_LCD_CmdWrite(0x57);//VSBE1
	temp1 = RA8875_LCD_DataRead();
	temp1 &= 0x80;
	temp=temp|temp1; 
	RA8875_LCD_CmdWrite(0x57);//VSBE1  
	RA8875_LCD_DataWrite(temp);


	temp=YB;   
	RA8875_LCD_CmdWrite(0x5a);//VDBE0
	RA8875_LCD_DataWrite(temp);
	temp=YB>>8;   
	RA8875_LCD_CmdWrite(0x5b);//VDBE1
	temp1 = RA8875_LCD_DataRead();
	temp1 &= 0x80;
	temp=temp|temp1;	
	RA8875_LCD_CmdWrite(0x5b);//VDBE1   
	RA8875_LCD_DataWrite(temp);
}							

void Source_Layer1(void)
{   
	uchar temp;	
	RA8875_LCD_CmdWrite(0x57);//VSBE1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Source_Layer2(void)
{	uchar temp;	
	RA8875_LCD_CmdWrite(0x57);//VSBE1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Destination_Layer1(void)
{	uchar temp;	
	RA8875_LCD_CmdWrite(0x5b);//VDBE1
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);
}

void Destination_Layer2(void)
{	uchar temp;	
	RA8875_LCD_CmdWrite(0x5b);//VDBE1
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);
}
		  
//---------------------------------------------//
//---------------------------------------------//
void BTE_Size_setting(uint X,uint Y)
{	
	uchar temp;
	temp=X;   
	RA8875_LCD_CmdWrite(0x5c);//BEWR0
	RA8875_LCD_DataWrite(temp);
	temp=X>>8;   
	RA8875_LCD_CmdWrite(0x5d);//BEWR1	   
	RA8875_LCD_DataWrite(temp);

	temp=Y;   
	RA8875_LCD_CmdWrite(0x5e);//BEHR0
	RA8875_LCD_DataWrite(temp);
	temp=Y>>8;   
	RA8875_LCD_CmdWrite(0x5f);//BEHR1	   
	RA8875_LCD_DataWrite(temp);
}									 

//---------------------------------------------//
//REG[60h]~REG[67h]

void Background_color(uint color)
{
 #ifdef Color65k
		RA8875_LCD_CmdWrite(0x60);
		RA8875_LCD_DataWrite((color&0xf800)>>11);

		RA8875_LCD_CmdWrite(0x61);
		RA8875_LCD_DataWrite((color&0x07e0)>>5);

		RA8875_LCD_CmdWrite(0x62);
		RA8875_LCD_DataWrite((color&0x001f));
 #endif
	
 #ifdef Color256
		RA8875_LCD_CmdWrite(0x60);
		RA8875_LCD_DataWrite((color&0xf800)>>13);

		RA8875_LCD_CmdWrite(0x61);
		RA8875_LCD_DataWrite((color&0x07e0)>>8);

		RA8875_LCD_CmdWrite(0x62);
		RA8875_LCD_DataWrite((color&0x001f)>>3);
 #endif
}

 void Text_color(uint color) 
{
 #ifdef Color65k
		RA8875_LCD_CmdWrite(0x63);
		RA8875_LCD_DataWrite((color&0xf800)>>11);

		RA8875_LCD_CmdWrite(0x64);
		RA8875_LCD_DataWrite((color&0x07e0)>>5);

		RA8875_LCD_CmdWrite(0x65);
		RA8875_LCD_DataWrite((color&0x001f));
 #endif
 
  #ifdef Color256
		RA8875_LCD_CmdWrite(0x63);
		RA8875_LCD_DataWrite((color&0xf800)>>13);

		RA8875_LCD_CmdWrite(0x64);
		RA8875_LCD_DataWrite((color&0x07e0)>>8);

		RA8875_LCD_CmdWrite(0x65);
		RA8875_LCD_DataWrite((color&0x001f)>>3);
 #endif
 
}



//--------------------------------------------//
void Text_Background_Color1(uint b_color)
{
	
	RA8875_LCD_CmdWrite(0x60);//BGCR0
	RA8875_LCD_DataWrite((uchar)(b_color>>11));
	
	RA8875_LCD_CmdWrite(0x61);//BGCR0
	RA8875_LCD_DataWrite((uchar)(b_color>>5));
	
	RA8875_LCD_CmdWrite(0x62);//BGCR0
	RA8875_LCD_DataWrite((uchar)(b_color));
	
	//--------------------------------------------//

} 
void Text_Background_Color(uchar setR, setG, setB)
{
	RA8875_LCD_CmdWrite(0x60);//BGCR0
	RA8875_LCD_DataWrite(setR);

	RA8875_LCD_CmdWrite(0x61);//BGCR0
	RA8875_LCD_DataWrite(setG);

	RA8875_LCD_CmdWrite(0x62);//BGCR0
	RA8875_LCD_DataWrite(setB);
} 
//--------------------------------------------//
void Text_Foreground_Color1(uint b_color)
{
	
	RA8875_LCD_CmdWrite(0x63);//BGCR0
	RA8875_LCD_DataWrite((uchar)(b_color>>11));
	
	RA8875_LCD_CmdWrite(0x64);//BGCR0
	RA8875_LCD_DataWrite((uchar)(b_color>>5));
	
	RA8875_LCD_CmdWrite(0x65);//BGCR0
	RA8875_LCD_DataWrite((uchar)(b_color));
	
	//--------------------------------------------//

} 

void Text_Foreground_Color(uchar setR,setG,setB)
{	    
	RA8875_LCD_CmdWrite(0x63);//BGCR0
	RA8875_LCD_DataWrite(setR);

	RA8875_LCD_CmdWrite(0x64);//BGCR0
	RA8875_LCD_DataWrite(setG);

	RA8875_LCD_CmdWrite(0x65);//BGCR0
	RA8875_LCD_DataWrite(setB);

}


void BTE_Background_color(uchar setR,setG,setB)
{
	RA8875_LCD_CmdWrite(0x60);//BGCR0
	RA8875_LCD_DataWrite(setR);
	RA8875_LCD_CmdWrite(0x61);//BGCR0
	RA8875_LCD_DataWrite(setG);
	RA8875_LCD_CmdWrite(0x62);//BGCR0
	RA8875_LCD_DataWrite(setB);
}


void BTE_Foreground_color(uchar setR,setG,setB)
{
	RA8875_LCD_CmdWrite(0x63);//BGCR0
	RA8875_LCD_DataWrite(setR);
	RA8875_LCD_CmdWrite(0x64);//BGCR0
	RA8875_LCD_DataWrite(setG);
	RA8875_LCD_CmdWrite(0x65);//BGCR0
	RA8875_LCD_DataWrite(setB);
}


//======================================
//for test
void BTE_Background_red(uchar setx)
{	  
	RA8875_LCD_CmdWrite(0x60);//BGCR0
	RA8875_LCD_DataWrite(setx);
}	
						
void BTE_Background_green(uchar setx)
{	  
	RA8875_LCD_CmdWrite(0x61);//BGCR1
	RA8875_LCD_DataWrite(setx);
}							  

void BTE_Background_blue(uchar setx)
{	 
	RA8875_LCD_CmdWrite(0x62);//BGCR2
	RA8875_LCD_DataWrite(setx);
} 								

void BTE_Foreground_red(uchar setx)
{	
	RA8875_LCD_CmdWrite(0x63);//FGCR0
	RA8875_LCD_DataWrite(setx);
}								 

void BTE_Foreground_green(uchar setx)
{	  
	RA8875_LCD_CmdWrite(0x64);//FGCR1
	RA8875_LCD_DataWrite(setx);
}							 

void BTE_Foreground_blue(uchar setx)
{  
	RA8875_LCD_CmdWrite(0x65);//FGCR2
	RA8875_LCD_DataWrite(setx);
} 	

//======================================
	
void Pattern_Set_8x8(void)
{  
 uchar temp;

 RA8875_LCD_CmdWrite(0x66);//PTNO
 temp = RA8875_LCD_DataRead();
 temp &= cClrD7;
 RA8875_LCD_DataWrite(temp);
}	

void Pattern_Set_16x16(void)
{  
	uchar  temp;

 RA8875_LCD_CmdWrite(0x66);//PTNO
 temp = RA8875_LCD_DataRead();
 temp |= cSetD7; 
 RA8875_LCD_DataWrite(temp);
}								

void Pattern_Set_number(uchar setx)
{  
	RA8875_LCD_CmdWrite(0x66);//PTNO
	RA8875_LCD_DataWrite(setx);
} 							

void BackgroundColor_TransparentMode(uchar setR,uchar setG,uchar setB)
{
	RA8875_LCD_CmdWrite(0x67);//BGTR_R
	RA8875_LCD_DataWrite(setR);

	RA8875_LCD_CmdWrite(0x68);//BGTR_G
	RA8875_LCD_DataWrite(setG);

	RA8875_LCD_CmdWrite(0x69);//BGTR_B
	RA8875_LCD_DataWrite(setB);

}	  

//REG[70h]~REG[74h]
//==============================================================================
//Subroutine:	Enable_TP 
//==============================================================================
void Enable_TP(void)
{   
	uchar temp;	  
	RA8875_LCD_CmdWrite(0x70);//TPCR0	
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7;   
	RA8875_LCD_DataWrite(temp);
}
//==============================================================================
//Subroutine:	Disable_TP 
//==============================================================================
void Disable_TP(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x70);//TPCR0
  temp = RA8875_LCD_DataRead();
  temp &= cClrD7;   
  RA8875_LCD_DataWrite(temp);
 }

//==============================================================================
//Subroutine:	Enable_Touch_WakeUp
//==============================================================================
void Enable_Touch_WakeUp(void)
{
  uchar temp;
	RA8875_LCD_CmdWrite(0x70);//TPCR0	
	temp = RA8875_LCD_DataRead();
	temp |= cSetD3;   //cSetb3 = 00001000
	RA8875_LCD_DataWrite(temp);
}
//==============================================================================
//Subroutine:	Disable_Touch_WakeUp
//==============================================================================
void Disable_Touch_WakeUp(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x70);//TPCR0	
	temp = RA8875_LCD_DataRead();
	temp &= cClrD3;
	RA8875_LCD_DataWrite(temp);
}

//==============================================================================
//Subroutine:	TP manual or auto  mode enable
//==============================================================================
void TP_manual_mode(void)
{	
	uchar temp;
	RA8875_LCD_CmdWrite(0x71);//TPCR1	
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6;
	RA8875_LCD_DataWrite(temp);
}
void TP_auto_mode(void)
{	
	uchar temp;
	RA8875_LCD_CmdWrite(0x71);//TPCR1	
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6;
	RA8875_LCD_DataWrite(temp);
}
//==============================================================================
//Subroutine:	TP_IDLE_mode
//==============================================================================
void TP_IDLE_mode(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x71);//TPCR1
  temp=RA8875_LCD_DataRead(); 
  temp &= 0xf0;
  RA8875_LCD_DataWrite(temp);
 }
//==============================================================================
//Subroutine:	TP_event_mode
//==============================================================================
void TP_event_mode(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x71);//TPCR1
  temp=RA8875_LCD_DataRead(); 
  temp &= 0xf0;
  temp |= 0x01;
  RA8875_LCD_DataWrite(temp);
//  RA8875_LCD_DataWrite(0xc1);
}
//==============================================================================
//Subroutine:	TP_latch_X
//==============================================================================
void TP_latch_X(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x71);//TPCR1
  temp=RA8875_LCD_DataRead(); 
  temp &= 0xc0;
  temp |= 0x02;
  RA8875_LCD_DataWrite(temp);
 }
 //==============================================================================
//Subroutine:	TP_latch_Y
//==============================================================================
void TP_latch_Y(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0x71);//TPCR1
  temp=RA8875_LCD_DataRead(); 
  temp &= 0xc0;
  temp |= 0x03;
  RA8875_LCD_DataWrite(temp);
 }
//==============================================================================
//Subroutine:	Detect_TP_X_Y coordinate 
//==============================================================================
uchar ADC_X(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x72);//TPXH	 X_coordinate high byte
	//Chk_Busy();
	temp=RA8875_LCD_DataRead();
	return temp;
}

uchar ADC_Y(void)
{	uchar temp;
	RA8875_LCD_CmdWrite(0x73);//TPYH	  Y_coordinate high byte
	//Chk_Busy();
	temp=RA8875_LCD_DataRead();
	return temp;
}

uchar ADC_XY(void)
{	uchar temp;
 	RA8875_LCD_CmdWrite(0x74);//TPXYL	  bit[3:2] Y_coordinate low byte  bit[1:0] X_coordinate low byte 
	temp=RA8875_LCD_DataRead();
	return temp;
}   



//REG[80h]~REG[83h]
void Graphic_Cursor_Coordinate(uint X,uint Y)
{
	uchar temp;

	temp=X;   
	RA8875_LCD_CmdWrite(0x80);
	RA8875_LCD_DataWrite(temp);
	temp=X>>8;   
	RA8875_LCD_CmdWrite(0x81);	   
	RA8875_LCD_DataWrite(temp);

	temp=Y;   
	RA8875_LCD_CmdWrite(0x82);
	RA8875_LCD_DataWrite(temp);
	temp=Y>>8;   
	RA8875_LCD_CmdWrite(0x83);	   
	RA8875_LCD_DataWrite(temp);
}

//---------------------------------//
//REG[84h]

void Graphic_Cursor_Color_0(uchar setx)
{	  
	RA8875_LCD_CmdWrite(0x84);//GCC0
	RA8875_LCD_DataWrite(setx); 
}  									  

void Graphic_Cursor_Color_1(uchar setx)
{	 
	RA8875_LCD_CmdWrite(0x85);//GCC1
	RA8875_LCD_DataWrite(setx); 
}  	
 	 						  
//---------------------------------------------//
//REG[8A]
void PWM1_enable(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);  
 }

void PWM1_disable(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);  
 }

void PWM1_disable_level_low(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6 ;
	RA8875_LCD_DataWrite(temp);  
}

void PWM1_disable_level_high(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6 ;
	RA8875_LCD_DataWrite(temp);  
}

 void PWM1_fnuction_sel(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD4 ;
	RA8875_LCD_DataWrite(temp);  
 }

 void PWM1_system_clk_out(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD4 ;
	RA8875_LCD_DataWrite(temp);  
 }

 void PWM1_clock_ratio(uchar setx) //bit0~3 
{
	uchar temp,temp1;
	temp1= setx&0x0f;
	RA8875_LCD_CmdWrite(0x8a);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= 0xf0;
	temp |= temp1 ;
	RA8875_LCD_DataWrite(temp);  
 }

 void PWM1_duty_cycle(uchar setx) //bit0~7
{
  
    RA8875_LCD_CmdWrite(0x8b);//PTNO
	RA8875_LCD_DataWrite(setx);
} 	

void PWM2_enable(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp);  
 }

void PWM2_disable(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);  
 }

void PWM2_disable_level_low(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6 ;
	RA8875_LCD_DataWrite(temp);  
}

void PWM2_disable_level_high(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6 ;
	RA8875_LCD_DataWrite(temp);  
}

 void PWM2_fnuction_sel(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD4 ;
	RA8875_LCD_DataWrite(temp);  
 }

  void PWM2_system_clk_out(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD4 ;
	RA8875_LCD_DataWrite(temp);  
 }

  void PWM2_clock_ratio(uchar setx) //bit0~3 
{
	uchar temp,temp1;
	temp1= setx&0x0f;
	RA8875_LCD_CmdWrite(0x8c);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= 0xf0;
	temp |= temp1 ;
	RA8875_LCD_DataWrite(temp);  
 }
 void PWM2_duty_cycle(uchar setx) //bit0~7
{  
	RA8875_LCD_CmdWrite(0x8d);//PTNO
	RA8875_LCD_DataWrite(setx);
} 	


//---------------------------------------------//
//REG[8Eh]
void Stop_Memory_Clear(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8e);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD7 ;
	RA8875_LCD_DataWrite(temp);  
}						 
void Memory_Clear(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8e);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD7 ;
	RA8875_LCD_DataWrite(temp); 
	Chk_Busy(); 
}
void Clear_Full_Window(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8e);//MCLR
	temp = RA8875_LCD_DataRead();
	temp &= cClrD6 ;
	RA8875_LCD_DataWrite(temp);  
}
void Clear_Active_Window(void)
{
	uchar temp;
	RA8875_LCD_CmdWrite(0x8e);//MCLR
	temp = RA8875_LCD_DataRead();
	temp |= cSetD6 ;
	RA8875_LCD_DataWrite(temp);  
}

									
//---------------------------------------------//
//REG[90h] 
void Draw_line(void)
{ 
  RA8875_LCD_CmdWrite(0x90);//DCR
  RA8875_LCD_DataWrite(0x00);
  RA8875_LCD_DataWrite(0x80);
}

void Draw_square(void)
{
  RA8875_LCD_CmdWrite(0x90);//DCR
  RA8875_LCD_DataWrite(0x10);
  RA8875_LCD_DataWrite(0x90);
}

void Draw_square_fill(void)
{
  RA8875_LCD_CmdWrite(0x90);//DCR
  RA8875_LCD_DataWrite(0x10);
  RA8875_LCD_DataWrite(0xb0);
}

void Draw_circle(void)
{
  RA8875_LCD_CmdWrite(0x90);//DCR
  RA8875_LCD_DataWrite(0x40);
}

void Draw_circle_fill(void)
{
  RA8875_LCD_CmdWrite(0x90);//DCR
  RA8875_LCD_DataWrite(0x60);
}

void Draw_Triangle(void)
{
   RA8875_LCD_CmdWrite(0x90);//DCR
   RA8875_LCD_DataWrite(0x00);
   RA8875_LCD_DataWrite(0x81);
}

void Draw_Triangle_fill(void)
{
   RA8875_LCD_CmdWrite(0x90);//DCR
   RA8875_LCD_DataWrite(0x01);
   RA8875_LCD_DataWrite(0xA1);
}

//---------------------------------------------//
//REG[90h]~/EG[9Dh]  									
void Geometric_Coordinate(uint XL,uint XR ,uint YT ,uint YB)
{	
uchar temp;    
temp=XL;   
	RA8875_LCD_CmdWrite(0x91);
RA8875_LCD_DataWrite(temp);
temp=XL>>8;   
	RA8875_LCD_CmdWrite(0x92);	   
RA8875_LCD_DataWrite(temp);

temp=XR;   
	RA8875_LCD_CmdWrite(0x95);
RA8875_LCD_DataWrite(temp);
temp=XR>>8;   
	RA8875_LCD_CmdWrite(0x96);	   
RA8875_LCD_DataWrite(temp);
	 
temp=YT;   
	RA8875_LCD_CmdWrite(0x93);
RA8875_LCD_DataWrite(temp);
temp=YT>>8;   
	RA8875_LCD_CmdWrite(0x94);	   
RA8875_LCD_DataWrite(temp);

temp=YB;   
	RA8875_LCD_CmdWrite(0x97);
RA8875_LCD_DataWrite(temp);
temp=YB>>8;   
	RA8875_LCD_CmdWrite(0x98);	   
RA8875_LCD_DataWrite(temp);
}

void Circle_Coordinate_Radius(uint X,uint Y,uint R)
{
		uchar temp;

		temp=X;   
		RA8875_LCD_CmdWrite(0x99);
		RA8875_LCD_DataWrite(temp);
		temp=X>>8;   
		RA8875_LCD_CmdWrite(0x9a);	   
		RA8875_LCD_DataWrite(temp);  

		temp=Y;   
		RA8875_LCD_CmdWrite(0x9b);
		RA8875_LCD_DataWrite(temp);
		temp=Y>>8;   
		RA8875_LCD_CmdWrite(0x9c);	   
		RA8875_LCD_DataWrite(temp);

		temp=R;   
		RA8875_LCD_CmdWrite(0x9d);
		RA8875_LCD_DataWrite(temp);
} 

//---------------------------------------------//
//REG[A0h] 
//void Draw_Ellipse(void)
//{
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   RA8875_LCD_DataWrite(0x00);
//   RA8875_LCD_DataWrite(0x80);
//}
//
//void Draw_Ellipse_Curve(uchar mode)
//{  uchar temp;
//
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   temp = RA8875_LCD_DataRead();
//   temp &=0x1F;
//   temp |= (0x90 | mode);
//   RA8875_LCD_DataWrite(temp);
//}
//
//void Draw_Ellipse_Curve_Fill(uchar mode)
//{  uchar temp;
//
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   temp = RA8875_LCD_DataRead();
//   temp &=0x1F;
//   temp |= (0xD0 | mode);
//   RA8875_LCD_DataWrite(temp);
//}
//
//void Draw_Ellipse_fill(void)
//{
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   RA8875_LCD_DataWrite(0x40);
//   RA8875_LCD_DataWrite(0xC0);
//}
//
//void Draw_Circle_Square(void)
//{
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   RA8875_LCD_DataWrite(0x20);
//   RA8875_LCD_DataWrite(0xA0);
//}
//
//void Draw_Circle_Square_fill(void)
//{
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   RA8875_LCD_DataWrite(0x60);
//   RA8875_LCD_DataWrite(0xE0);
//}
//
//
//void Draw_Ellipse_Curve_part(uchar setx)
//{
//   uchar temp,temp1;
//   RA8875_LCD_CmdWrite(0xA0);//DCR
//   temp = RA8875_LCD_DataRead();
//   temp1 = setx&0x03;
//   temp &=0xfc;
//   temp |=temp1;
//   RA8875_LCD_DataWrite(temp);   
//}


//void Ellipse_Coordinate_setting(uint X,uint Y,uint ELL_A,uint ELL_B)
//{
//		uchar temp;    
//		temp=X;   
//		RA8875_LCD_CmdWrite(0xA5);
//		RA8875_LCD_DataWrite(temp);
//		temp=X>>8;   
//		RA8875_LCD_CmdWrite(0xA6);	   
//		RA8875_LCD_DataWrite(temp);  
//
//		temp=Y;   
//		RA8875_LCD_CmdWrite(0xA7);
//		RA8875_LCD_DataWrite(temp);
//		temp=Y>>8;   
//		RA8875_LCD_CmdWrite(0xA8);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=ELL_A;   
//		RA8875_LCD_CmdWrite(0xA1);
//		RA8875_LCD_DataWrite(temp);
//		temp=ELL_A>>8;
//		RA8875_LCD_CmdWrite(0xA2);
//		RA8875_LCD_DataWrite(temp);
//
//		temp=ELL_B;   
//		RA8875_LCD_CmdWrite(0xA3);
//		RA8875_LCD_DataWrite(temp);
//		temp=ELL_B>>8;
//		RA8875_LCD_CmdWrite(0xA4);
//		RA8875_LCD_DataWrite(temp);
//} 



//void Circle_Square_Coordinate_setting(uint XL,uint XR ,uint YT ,uint YB ,uint ELL_A,uint ELL_B)
//{	
//		uchar temp;    
//		temp=XL;   
//		RA8875_LCD_CmdWrite(0x91);
//		RA8875_LCD_DataWrite(temp);
//		temp=XL>>8;   
//		RA8875_LCD_CmdWrite(0x92);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=XR;   
//		RA8875_LCD_CmdWrite(0x95);
//		RA8875_LCD_DataWrite(temp);
//		temp=XR>>8;   
//		RA8875_LCD_CmdWrite(0x96);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=YT;   
//		RA8875_LCD_CmdWrite(0x93);
//		RA8875_LCD_DataWrite(temp);
//		temp=YT>>8;   
//		RA8875_LCD_CmdWrite(0x94);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=YB;   
//		RA8875_LCD_CmdWrite(0x97);
//		RA8875_LCD_DataWrite(temp);
//		temp=YB>>8;   
//		RA8875_LCD_CmdWrite(0x98);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=ELL_A;   
//		RA8875_LCD_CmdWrite(0xA1);
//		RA8875_LCD_DataWrite(temp);
//		temp=ELL_A>>8;
//		RA8875_LCD_CmdWrite(0xA2);
//		RA8875_LCD_DataWrite(temp);
//
//		temp=ELL_B;   
//		RA8875_LCD_CmdWrite(0xA3);
//		RA8875_LCD_DataWrite(temp);
//		temp=ELL_B>>8;
//		RA8875_LCD_CmdWrite(0xA4);
//		RA8875_LCD_DataWrite(temp); 
//}

 
//void Draw_Triangle_3point_Coordinate(uint P1_X,uint P1_Y,uint P2_X,uint P2_Y,uint P3_X,uint P3_Y)
//{	
//		uchar temp;    
//		temp=P1_X;   
//		RA8875_LCD_CmdWrite(0x91);
//		RA8875_LCD_DataWrite(temp);
//		temp=P1_X>>8;   
//		RA8875_LCD_CmdWrite(0x92);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=P1_Y;   
//		RA8875_LCD_CmdWrite(0x93);
//		RA8875_LCD_DataWrite(temp);
//		temp=P1_Y>>8;   
//		RA8875_LCD_CmdWrite(0x94);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=P2_X;   
//		RA8875_LCD_CmdWrite(0x95);
//		RA8875_LCD_DataWrite(temp);
//		temp=P2_X>>8;   
//		RA8875_LCD_CmdWrite(0x96);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=P2_Y;   
//		RA8875_LCD_CmdWrite(0x97);
//		RA8875_LCD_DataWrite(temp);
//		temp=P2_Y>>8;   
//		RA8875_LCD_CmdWrite(0x98);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=P3_X;   
//		RA8875_LCD_CmdWrite(0xA9);
//		RA8875_LCD_DataWrite(temp);
//		temp=P3_X>>8;   
//		RA8875_LCD_CmdWrite(0xAA);	   
//		RA8875_LCD_DataWrite(temp);
//
//		temp=P3_Y;   
//		RA8875_LCD_CmdWrite(0xAB);
//		RA8875_LCD_DataWrite(temp);
//		temp=P3_Y>>8;   
//		RA8875_LCD_CmdWrite(0xAC);	   
//		RA8875_LCD_DataWrite(temp);   
//}

//---------------------------------------------//
//REG[B0]~REG[B3]
void DMA_Start_address_setting(ulong set_address)
{ uchar temp ;
  temp = set_address;
  RA8875_LCD_CmdWrite(0xB0);
  RA8875_LCD_DataWrite(temp);
  temp = set_address>>8;
  RA8875_LCD_CmdWrite(0xB1);
  RA8875_LCD_DataWrite(temp);
  temp = set_address>>16;
  RA8875_LCD_CmdWrite(0xB2);
  RA8875_LCD_DataWrite(temp);
  temp = set_address>>24;
  RA8875_LCD_CmdWrite(0xB3);
  RA8875_LCD_DataWrite(temp);

}

//input pic data quantity  for example  pic size = 800*480 = 384000
void DMA_Continuous_mode_size_setting(ulong set_size)
{ uchar temp;
  temp= set_size;
  RA8875_LCD_CmdWrite(0xB4);
  RA8875_LCD_DataWrite(temp);
  temp= set_size>>8;
  RA8875_LCD_CmdWrite(0xB6);
  RA8875_LCD_DataWrite(temp);
  temp= set_size>>16;
  RA8875_LCD_CmdWrite(0xB8);
  RA8875_LCD_DataWrite(temp);

}

void DMA_block_mode_size_setting(uint BWR,uint BHR,uint SPWR)
{ uchar temp;
  temp = BWR;
  RA8875_LCD_CmdWrite(0xB4);
  RA8875_LCD_DataWrite(temp);
  temp = BWR>>8;
  RA8875_LCD_CmdWrite(0xB5);
  RA8875_LCD_DataWrite(temp);

  temp = BHR;
  RA8875_LCD_CmdWrite(0xB6);
  RA8875_LCD_DataWrite(temp);
  temp = BHR>>8;
  RA8875_LCD_CmdWrite(0xB7);
  RA8875_LCD_DataWrite(temp);

  temp = SPWR;
  RA8875_LCD_CmdWrite(0xB8);
  RA8875_LCD_DataWrite(temp);
  temp = SPWR>>8;
  RA8875_LCD_CmdWrite(0xB9);
  RA8875_LCD_DataWrite(temp);  
}

//---------------------------------------------//
//REG[BFh]
void DMA_Continuous_mode(void)
{ 
  RA8875_LCD_CmdWrite(0xBF);
  RA8875_LCD_DataWrite(0x00);
}

void DMA_Block_mode(void)
{ 
  RA8875_LCD_CmdWrite(0xBF);
  RA8875_LCD_DataWrite(0x02);
}

void DMA_Start_enable(void)
{  
	uchar temp;
  RA8875_LCD_CmdWrite(0xBF);
  temp = RA8875_LCD_DataRead();
  temp |= 0x01;
  RA8875_LCD_DataWrite(temp);
}

//---------------------------------------------//
//REG[C0h]
void Key_Scan_Enable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xC0);
  temp = RA8875_LCD_DataRead();
  temp |= 0x80;
  RA8875_LCD_DataWrite(temp);  
}


void Key_Scan_setting(uchar setx)//bit[2:0]
{ uchar temp;
  RA8875_LCD_CmdWrite(0xC0);
  temp = RA8875_LCD_DataRead();
  temp &= 0xf0;
  temp|= (setx&0x07);
  RA8875_LCD_DataWrite(temp);  
} 

void Long_Key_Scan_enable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xC0);
  temp = RA8875_LCD_DataRead();
  temp |= 0x40;
  RA8875_LCD_DataWrite(temp);
}

void Key_Scan_Wakeup_Function_Enable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xC1);	
  temp = RA8875_LCD_DataRead();
  temp |= 0x80;	// 
  RA8875_LCD_DataWrite(temp);
}

void Long_Key_Timing_Adjustment(uchar setx)
{
  uchar temp,temp1;
  temp = setx & 0x1c;
  RA8875_LCD_CmdWrite(0xC1);
  temp1 = RA8875_LCD_DataRead();
  temp1|=temp;
  RA8875_LCD_DataWrite(temp1);   
 
}

//---------------------------------------------//
//REG[D0]
void Floating_window_start_point(uint X,uint Y)
{
   uchar temp;
   temp=X;
   RA8875_LCD_CmdWrite(0xD0);
   RA8875_LCD_DataWrite(temp);
   temp=X>>8;
   RA8875_LCD_CmdWrite(0xD1);
   RA8875_LCD_DataWrite(temp);
   temp=Y;
   RA8875_LCD_CmdWrite(0xD2);
   RA8875_LCD_DataWrite(temp);
   temp=Y>>8;
   RA8875_LCD_CmdWrite(0xD3);
   RA8875_LCD_DataWrite(temp);
   
}


void Floating_window_size(uint width_X,uint high_Y)
{
   uchar temp;
   temp=width_X;
   RA8875_LCD_CmdWrite(0xD4);
   RA8875_LCD_DataWrite(temp);
   temp=width_X>>8;
   RA8875_LCD_CmdWrite(0xD5);
   RA8875_LCD_DataWrite(temp);
   temp=high_Y;
   RA8875_LCD_CmdWrite(0xD6);
   RA8875_LCD_DataWrite(temp);
   temp=high_Y>>8;
   RA8875_LCD_CmdWrite(0xD7);
   RA8875_LCD_DataWrite(temp);

}

void Floating_window_display_point(uint X,uint Y)
{
   uchar temp;
   temp=X;
   RA8875_LCD_CmdWrite(0xD8);
   RA8875_LCD_DataWrite(temp);
   temp=X>>8;
   RA8875_LCD_CmdWrite(0xD9);
   RA8875_LCD_DataWrite(temp);
   temp=Y;
   RA8875_LCD_CmdWrite(0xDA);
   RA8875_LCD_DataWrite(temp);
   temp=Y>>8;
   RA8875_LCD_CmdWrite(0xDB);
   RA8875_LCD_DataWrite(temp);

}


//REG[E0h] 
void Serial_ROM_direct_access_mode_enable(void)
{
   RA8875_LCD_CmdWrite(0xE0);
   RA8875_LCD_DataWrite(0x01);
}

void Serial_ROM_direct_access_mode_disable(void)
{
   RA8875_LCD_CmdWrite(0xE0);
   RA8875_LCD_DataWrite(0x00);
}

void Direct_access_mode_Address_32bits(ulong set_address)
{
  uchar temp;
  
  temp = set_address>>24;
  RA8875_LCD_CmdWrite(0xE1);
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
  temp = set_address>>16;
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
  temp = set_address>>8;
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
  temp = set_address;
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
}

void Direct_access_mode_Address_24bits(ulong set_address)
{
  uchar temp=0;
  
  temp = set_address>>16;
  RA8875_LCD_CmdWrite(0xE1);
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
  
  temp = set_address>>8;
  RA8875_LCD_CmdWrite(0xE1);
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
    
  temp = set_address;
  RA8875_LCD_CmdWrite(0xE1);
  RA8875_LCD_DataWrite(temp);
  Chk_Busy_DIR_Access();
}

uchar Direct_access_mode_Read_Data_buffer(void)
{
   uchar Serial_Data;

   RA8875_LCD_CmdWrite(0xE2);
   Serial_Data=RA8875_LCD_DataRead(); 
   return Serial_Data;
}

//---------------------------------------------//



//---------------------------------------------//
//REG[F0h] 

void KEYSCAN_Interrupt_Enable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF0);	
  temp = RA8875_LCD_DataRead();
  temp |= 0x10;	// 
  RA8875_LCD_DataWrite(temp); 
}

void KEYSCAN_Interrupt_Disable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF0);	
  temp = RA8875_LCD_DataRead();
  temp &= 0x0F;	// 
  RA8875_LCD_DataWrite(temp); 
}


void DMA_Interrupt_Enable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF0);	
  temp = RA8875_LCD_DataRead();
  temp |= 0x08;	// 
  RA8875_LCD_DataWrite(temp); 
}

void DMA_Interrupt_Disable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF0);	
  temp = RA8875_LCD_DataRead();
  temp &= 0x17;	// 
  RA8875_LCD_DataWrite(temp); 
}

void Touch_Panel_Interrupt_Enable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF0);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp |= 0x04;
  RA8875_LCD_DataWrite(temp);
 }

void Touch_Panel_Interrupt_Disable(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF0);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp &= 0x1B;
  RA8875_LCD_DataWrite(temp);
 }

void BTE_Interrupt_Enable(void)
{
  uchar temp;
  RA8875_LCD_CmdWrite(0xF0);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp |= 0x02;
  RA8875_LCD_DataWrite(temp);
}

void BTE_Interrupt_Disable(void)
{
  uchar temp;
  RA8875_LCD_CmdWrite(0xF0);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp &= 0x1D;
  RA8875_LCD_DataWrite(temp);
}

void Font_BTE_read_write_Interrupt_Enable(void)
{
  uchar temp;
  RA8875_LCD_CmdWrite(0xF0);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp |= 0x01;
  RA8875_LCD_DataWrite(temp);
}

void Font_BTE_read_write_Interrupt_Disable(void)
{
  uchar temp;
  RA8875_LCD_CmdWrite(0xF0);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp &= 0x1E;
  RA8875_LCD_DataWrite(temp);
}

//---------------------------------------------//
//REG[F1h] 
void Clear_keyscan_interrupt(void)
{ uchar temp;
  RA8875_LCD_CmdWrite(0xF1);//INTC
  temp=RA8875_LCD_DataRead(); 
  temp |=cSetD4 ;
  RA8875_LCD_DataWrite(temp);
}


void Show_String(uchar *str)
{  
	Text_Mode();
	RA8875_LCD_CmdWrite(0x02);
	while(*str != '\0')
	{
		RA8875_LCD_DataWrite(*str);
		++str;	 	
		Chk_Busy();
	}
}
