/*******************************************
ͺ:OCM320240T350-1B
MCU :AT89S52
: RA8870
д:Bittern
:2010611
********************************************/

#include <reg52.h>

#define uchar      unsigned char
#define uint       unsigned int

#define MHz     1000000U           //  MHz
#define gCLK    (11.0592*MHz)      // ϵͳʱƵ(22.1184*MHz)
#define UART_BAUD   19200           // õĲ




#define Intel_8080_MCU //R27 0ŷ裬R28
//#define Motorola_6800_MCU //R27 R280ŷ

#define bit8//ʹ8λģʽ
//#define 16bit //ʹ16λģʽ



#ifdef bit8
#define DATA_BUS P1
#else 
#endif

#define	cSetD0		     0x01
#define	cSetD1		     0x02
#define	cSetD2		     0x04
#define	cSetD3		     0x08
#define	cSetD4		     0x10
#define	cSetD5		     0x20
#define	cSetD6		     0x40
#define	cSetD7		     0x80

#define	cClrD0		     0xfe
#define	cClrD1		     0xfd
#define	cClrD2		     0xfb
#define	cClrD3		     0xf7
#define	cClrD4		     0xef
#define	cClrD5		     0xdf
#define	cClrD6		     0xbf
#define	cClrD7		     0x7f

#define cClrD1D0         0xfc
#define cClrD1SetD0	     0x01
#define cSetD1ClrD0	     0x02
#define cSetD1D0		 0x03
#define cClrD3D2         0xf3
#define cClrD3SetD2      0x04
#define cSetD3ClrD2      0x08
#define cSetD3D2		 0x0c

#define cClrD2D1D0		 0xf8
#define cClrD2D1SetD0	 0x01
#define cClrD2SetD1ClrD0 0x02
#define cClrD2SetD1D0	 0x03
#define cSetD2ClrD1D0	 0x04
#define cSetD2ClrD1SetD0 0x05

#define cClrD6D5D4	     0x8f
#define cClrD6D5SetD4    0x10
#define cClrD6SetD5ClrD4 0x20
#define cClrD6SetD5D4	 0x30
#define cSetD6ClrD5D4	 0x40
#define cSetD6ClrD5SetD4 0x50
#define cSetD6D5ClrD4	 0x60
#define cSetD6D5D4		 0x70


#ifdef Intel_8080_MCU

sbit int0=P3^2;
sbit wait=P3^3;


sbit  rst=P2^5;
sbit  rs=P2^4;
sbit  cs=P2^3;
sbit  wr=P2^2;
sbit  rd=P2^1;
sbit  led=P2^0;



void LCD_CmdWrite(uchar cmd) // Command Write
{ 
cs = 0;
rs = 1;
DATA_BUS = cmd;
wr = 0;
wr = 1;
cs= 1;
DATA_BUS = 0xff;
rs = 0;
}

uchar LCD_CmdRead(void) // Command ReadRead Register
{
uchar Data;
cs = 0;
rs= 1;
wr = 1;
rd = 0;
Data = DATA_BUS;
rd = 1;
cs = 1;
DATA_BUS = 0xff;
rs = 0;
return Data;
}

void LCD_DataWrite(uchar Data) // Data Write
{
cs = 0;
rs = 0;
DATA_BUS = Data;
wr = 0;
wr = 1;
cs = 1;
DATA_BUS = 0xff;
rs = 1;
}

uchar LCD_DataRead(void) // Data Read
{
uchar Data;
wr = 1;
cs = 0;
rs = 0;
rd = 0;
Data = DATA_BUS;
rd = 1;
cs = 1;
rs = 1;
return Data;
}

uchar LCD_StatusRead(void) // Read Status Register
{
uchar Data;
cs = 0;
rs= 1;
wr = 1;
rd = 0;
Data = DATA_BUS;
rd = 1;
cs= 1;
DATA_BUS = 0xff;
rs = 0;
return Data;
}

#else 


#endif

// ========== ӳ٣Dealy ӳ ===========
void Delay2us(uchar Counter)
{ while(--Counter);
}
void Delay100us(uchar Counter)
{ while(Counter--)
{ Delay2us(100); }
}
void Delay1ms(uchar Counter)
{ while(Counter--)
{ Delay100us(11); }
}
void Delay10ms(uchar Counter)
{ while(Counter--)
{ Delay1ms(11); }
}
void Delay100ms(uchar Counter)
{ while(Counter--)
{ Delay1ms(101); }
}


// ========== æCheck Busy ӳ ===========
void Chk_Busy(void)
{ uchar temp;
do
{ temp=LCD_StatusRead();
} while((temp&0x80)==0x80);
}

// ========== Hardware Reset ===========
void LCD_Reset(void)
{ 
rst = 0;
Delay100ms(1);
rst = 1;
Delay100ms(1);
Chk_Busy();
}


void PWM1_enable(void)
{
	uchar temp;
	LCD_CmdWrite(0x8a);//MCLR
	temp = LCD_DataRead();
	temp |= cSetD7 ;
	LCD_CmdWrite(0x8a);//MCLR
	LCD_DataWrite(temp);  
 }

void RA8870_PLL_ini(void)
{
    LCD_CmdWrite(0x88);     
    LCD_DataWrite(0x07);  
    LCD_CmdWrite(0x89);     
    LCD_DataWrite(0x03);
    //Delay100ms(1);
    LCD_CmdWrite(0x01);     
    LCD_DataWrite(0x01);
    LCD_DataWrite(0x00);
    Delay100ms(1);

}	

 void PWM1_clock_ratio(uchar divide) //bit0~3 
{
	uchar temp,temp1;
	temp1= divide&0x0f;
	LCD_CmdWrite(0x8a);//MCLR
	temp = LCD_DataRead();
	temp &= 0xf0;
	temp |= temp1 ;
	LCD_CmdWrite(0x8a);//MCLR
	LCD_DataWrite(temp);  
 }

 void PWM1_fnuction_sel(void)
{
	uchar temp;
	LCD_CmdWrite(0x8a);//MCLR
	temp = LCD_DataRead();
	temp &= cClrD4 ;
	LCD_CmdWrite(0x8a);//MCLR
	LCD_DataWrite(temp);  
 }

 void PWM1_duty_cycle(uchar setx) //bit0~7
{
	uchar temp;
	temp=setx;   
    LCD_CmdWrite(0x8b);//PTNO
	LCD_DataWrite(temp);
} 	

// ========== RA8870 ʼ ===========
void LCD_Initial(void)
{
/*
    LCD_CmdWrite(0x10);  //SYSR   bit[4:3]=00 256 color  bit[2:1]=  00 8bit MPU interface
//LCD_DataWrite(0x3C); //          01 4k  color  01 12bit
LCD_DataWrite(0x04);   //                 1x 64k color             1x 16bit   
LCD_CmdWrite(0x11);  //DRGB bit[2:0]  data bus of parallel panel  000=RGB 001=RBG
LCD_DataWrite(0x00); 
LCD_CmdWrite(0x12);  //IOCR  GPIO& analog TFT interface
LCD_DataWrite(0x00); //

LCD_CmdWrite(0x13);  //IODR  GPIO
LCD_DataWrite(0x05);

LCD_CmdWrite(0x14);  //HDWR//Horizontal Display Width Setting Bit[6:0] 
LCD_DataWrite(0x27); //Horizontal display width(pixels) = (HDWR + 1)*8 
    LCD_CmdWrite(0x15);  //HNDFCR//Horizontal Non-Display Period fine tune Bit[3:0] 
LCD_DataWrite(0x02); //(HNDR + 1)*8 +HNDFCR
LCD_CmdWrite(0x16);  //HNDR//Horizontal Non-Display Period Bit[4:0] 
LCD_DataWrite(0x03); //Horizontal Non-Display Period (pixels) = (HNDR + 1)*8 
LCD_CmdWrite(0x17);  //HSTR//HSYNC Start Position[4:0] 
LCD_DataWrite(0x01); //HSYNC Start Position(PCLK) = (HSTR + 1)*8 
LCD_CmdWrite(0x18);  //HPWR//HSYNC Polarity ,The period width of HSYNC. 
LCD_DataWrite(0x03); //HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8 

//Vertical set
LCD_CmdWrite(0x19); //VDHR0 //Vertical Display Height Bit [7:0] 
LCD_DataWrite(0xef); //Vertical pixels = VDHR + 1
LCD_CmdWrite(0x1a); //VDHR1 //Vertical Display Height Bit [8] 
LCD_DataWrite(0x00); //Vertical pixels = VDHR + 1 
LCD_CmdWrite(0x1b); //VNDR0 //Vertical Non-Display Period Bit [7:0]
LCD_DataWrite(0x0F); //Vertical Non-Display area = (VNDR + 1) 
LCD_CmdWrite(0x1c); //VNDR1 //Vertical Non-Display Period Bit [8] 
LCD_DataWrite(0x00); //Vertical Non-Display area = (VNDR + 1) 
LCD_CmdWrite(0x1d); //VSTR0 //VSYNC Start Position[7:0]
LCD_DataWrite(0x0e); //VSYNC Start Position(PCLK) = (VSTR + 1) 
LCD_CmdWrite(0x1e); //VSTR1 //VSYNC Start Position[8] 
LCD_DataWrite(0x06); //VSYNC Start Position(PCLK) = (VSTR + 1) 
LCD_CmdWrite(0x1f);  //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]
LCD_DataWrite(0x01); //VSYNC Pulse Width(PCLK) = (VPWR + 1) 

LCD_CmdWrite(0x28);  //if use font ROM Speed setting
LCD_DataWrite(0x02);


LCD_CmdWrite(0x8A);  //PWM1
LCD_DataWrite(0x82);
LCD_CmdWrite(0x8B);  //
LCD_DataWrite(0x10);

LCD_CmdWrite(0x8A);  //PWM2
LCD_DataWrite(0x82);
LCD_CmdWrite(0x8B);  //
LCD_DataWrite(0x2a);
*/

RA8870_PLL_ini();

	LCD_CmdWrite(0x10);	 //SYSR   bit[4:3]=00 256 color  bit[2:1]=  00 8bit MPU interface
	//LCD_DataWrite(0x3C); //		        	01 4k  color			 01 12bit
	LCD_DataWrite(0x04);   //                 1x 64k color             1x	16bit 						 
	LCD_CmdWrite(0x11);	 //DRGB bit[2:0]  data bus of parallel panel  000=RGB 001=RBG
	LCD_DataWrite(0x00); 
	LCD_CmdWrite(0x12);	 //IOCR  GPIO& analog TFT interface
	LCD_DataWrite(0x00); //
	LCD_CmdWrite(0x13);	 //IODR  GPIO
	LCD_DataWrite(0x05);



	//Horizontal set
	LCD_CmdWrite(0x14);	 //HDWR//Horizontal Display Width Setting Bit[6:0] 
	LCD_DataWrite(0x27); //Horizontal display width(pixels) = (HDWR + 1)*8 
    LCD_CmdWrite(0x15);	 //HNDFCR//Horizontal Non-Display Period fine tune Bit[3:0] 
	LCD_DataWrite(0x02); //(HNDR + 1)*8 +HNDFCR
	LCD_CmdWrite(0x16);	 //HNDR//Horizontal Non-Display Period Bit[4:0] 
	LCD_DataWrite(0x03); //Horizontal Non-Display Period (pixels) = (HNDR + 1)*8 
	LCD_CmdWrite(0x17);	 //HSTR//HSYNC Start Position[4:0] 
	LCD_DataWrite(0x01); //HSYNC Start Position(PCLK) = (HSTR + 1)*8 
	LCD_CmdWrite(0x18);	 //HPWR//HSYNC Polarity ,The period width of HSYNC. 
	LCD_DataWrite(0x03); //HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8 

	//Vertical set
	LCD_CmdWrite(0x19); //VDHR0 //Vertical Display Height Bit [7:0] 
	LCD_DataWrite(0xef); //Vertical pixels = VDHR + 1
	LCD_CmdWrite(0x1a); //VDHR1 //Vertical Display Height Bit [8] 
	LCD_DataWrite(0x00); //Vertical pixels = VDHR + 1 
	LCD_CmdWrite(0x1b); //VNDR0 //Vertical Non-Display Period Bit [7:0]
	LCD_DataWrite(0x0F); //Vertical Non-Display area = (VNDR + 1) 
	LCD_CmdWrite(0x1c); //VNDR1 //Vertical Non-Display Period Bit [8] 
	LCD_DataWrite(0x00); //Vertical Non-Display area = (VNDR + 1) 
	LCD_CmdWrite(0x1d); //VSTR0 //VSYNC Start Position[7:0]
	LCD_DataWrite(0x0e); //VSYNC Start Position(PCLK) = (VSTR + 1) 
	LCD_CmdWrite(0x1e); //VSTR1 //VSYNC Start Position[8] 
	LCD_DataWrite(0x06); //VSYNC Start Position(PCLK) = (VSTR + 1) 
	LCD_CmdWrite(0x1f);	 //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]
	LCD_DataWrite(0x01); //VSYNC Pulse Width(PCLK) = (VPWR + 1) 

	//----PWM initial for Backlight  add by mountain 
    PWM1_enable();
    PWM1_fnuction_sel();
    PWM1_clock_ratio(0x08); //bit0~3     for 3.5"TFT  ra8870_demo_v3
    //PWM1_duty_cycle(0x80);//b
    PWM1_duty_cycle(0x02); // ȫ

	//LCD_CmdWrite(0x04); //PCLK
	//LCD_DataWrite(0x00); //
	LCD_CmdWrite(0x28);  //if use font ROM Speed setting
	LCD_DataWrite(0x02);

}


// ========== 趨TFT ֱӳ ===========
void Active_Window(uint XL,uint XR ,uint YT ,uint YB)
{ uchar temp;
//setting active window X
temp=XL;
LCD_CmdWrite(0x30); //HSAW0
LCD_DataWrite(temp);
temp=XL>>8;
LCD_CmdWrite(0x31); //HSAW1
LCD_DataWrite(temp);
temp=XR;
LCD_CmdWrite(0x34); //HEAW0
LCD_DataWrite(temp);
temp=XR>>8;
LCD_CmdWrite(0x35); //HEAW1
LCD_DataWrite(temp);
//setting active window Y
temp=YT;
LCD_CmdWrite(0x32); //VSAW0
LCD_DataWrite(temp);
temp=YT>>8;
LCD_CmdWrite(0x33); //VSAW1
LCD_DataWrite(temp);
temp=YB;
LCD_CmdWrite(0x36); //VEAW0
LCD_DataWrite(temp);
temp=YB>>8;
LCD_CmdWrite(0x37); //VEAW1
LCD_DataWrite(temp);
}

// ==========ʾڴӳ ===========
void Memory_Clear(void)
{ uchar temp;
LCD_CmdWrite(0x8e); //MCLR
temp = LCD_DataRead();
temp |= cSetD7 ;
LCD_CmdWrite(0x8e); //MCLR
LCD_DataWrite(temp);
Chk_Busy();
}

// ========== 趨ǰɫӳ ===========
void Text_Foreground_Color(uint color)
{ uchar temp;
temp=color;
LCD_CmdWrite(0x42); //TFCR
LCD_DataWrite(temp);
}

// ========== 趨ֱɫӳ ===========
void Text_Background_Color(uint color)
{ uchar temp;
temp=color;
LCD_CmdWrite(0x43); //TBCR
LCD_DataWrite(temp);
}

// ========== 趨ʾڴʱֱɫΪӳ ===========
void Memory_Clear_with_Font_BgColor(void)
{ uchar temp;
LCD_CmdWrite(0x8e); //MCLR
temp = LCD_DataRead();
temp |= cSetD0 ;
LCD_CmdWrite(0x8e); //MCLR
LCD_DataWrite(temp);
}
// ========== 趨ӳ ===========
void Geometric_Coordinate(uint XL,uint XR ,uint YT ,uint YB)
{ uchar temp;
temp=XL;
LCD_CmdWrite(0x91);
LCD_DataWrite(temp);
temp=XL>>8;
LCD_CmdWrite(0x92);
LCD_DataWrite(temp);
temp=XR;
LCD_CmdWrite(0x95);
LCD_DataWrite(temp);
temp=XR>>8;
LCD_CmdWrite(0x96);
LCD_DataWrite(temp);
temp=YT;
LCD_CmdWrite(0x93);
LCD_DataWrite(temp);
temp=YT>>8;
LCD_CmdWrite(0x94);
LCD_DataWrite(temp);
temp=YB;
LCD_CmdWrite(0x97);
LCD_DataWrite(temp);
temp=YB>>8;
LCD_CmdWrite(0x98);
LCD_DataWrite(temp);
}
// ========== 趨Բ뾶ӳ ===========
void Circle_Coordinate_Radius(uint X,uint Y,uint R)
{ uchar temp;
temp=X;
LCD_CmdWrite(0x99);
LCD_DataWrite(temp);
temp=X>>8;
LCD_CmdWrite(0x9a);
LCD_DataWrite(temp);
temp=Y;
LCD_CmdWrite(0x9b);
LCD_DataWrite(temp);
temp=Y>>8;
LCD_CmdWrite(0x9c);
LCD_DataWrite(temp);
temp=R;
LCD_CmdWrite(0x9d);
LCD_DataWrite(temp);
}

// ========== 趨ӳ ===========
void XY_Coordinate(uint X,uint Y)
{ uchar temp;
temp=X;
LCD_CmdWrite(0x46);
LCD_DataWrite(temp);
temp=X>>8;
LCD_CmdWrite(0x47);
LCD_DataWrite(temp);
temp=Y;
LCD_CmdWrite(0x48);
LCD_DataWrite(temp);
temp=Y>>8;
LCD_CmdWrite(0x49);
LCD_DataWrite(temp);
}
// ========== 趨ʾģʽӳ ===========
void Text_Mode(void)
{ uchar temp;
LCD_CmdWrite(0x40); //MWCR0
temp = LCD_DataRead();
temp |= cSetD7 ;
LCD_CmdWrite(0x40); //MWCR0
LCD_DataWrite(temp);
}
// ========== ʾӳ ===========
void Show_String(uchar *str,uint n)
{ Active_Window(0,319,0,239);
LCD_CmdWrite(0x02);
while(*str != '\0')
{ LCD_DataWrite(*str);
++str;
Chk_Busy();
Delay1ms(n);
}
Chk_Busy();
}

void CGROM_Font(void)
{
	uchar temp;

	LCD_CmdWrite(0x21);//FNCR0
	temp = LCD_DataRead();
	temp &= cClrD7 ;
	LCD_CmdWrite(0x21);//FNCR0
	LCD_DataWrite(temp);
}

void Internal_CGROM(void)
{
	uchar temp;

	LCD_CmdWrite(0x21);//FNCR0
	temp = LCD_DataRead();
	temp &= cClrD5 ;
	LCD_CmdWrite(0x21);//FNCR0
	LCD_DataWrite(temp);
}

void Show_Ascii(uchar ascii)
{
Text_Mode();
CGROM_Font();
Internal_CGROM();
LCD_CmdWrite(0x02);
LCD_DataWrite(ascii);
}



//==============================================================================
//Subroutine:	Enable_TP 
//==============================================================================
void Enable_TP(void)
{  uchar temp;	
    uchar a,b;
	
	a=0x40;         // TP sample time adjust
	b=0x04;         //ADC clock convert speed
	LCD_CmdWrite(0x70);//TPCR0	
	temp = LCD_DataRead();
	temp |= cSetD7;   
	temp |= a;
	temp |= b;
	LCD_CmdWrite(0x70);
	LCD_DataWrite(temp);
}


 //==============================================================================
//Subroutine:	enable_TP_interrupt_bit 
//==============================================================================
void enable_TP_interrupt(void)
{ uchar temp;
  LCD_CmdWrite(0x8F);//INTC
  temp=LCD_DataRead(); 
  temp |= cSetD6;
  LCD_DataWrite(temp);
 }



//==============================================================================
//Subroutine:	TP status
//==============================================================================
bit Touch_Status(void)
{	uchar temp;
	LCD_CmdWrite(0x8F);//INTC	
	temp = LCD_DataRead();
	if ((temp&0x04)==0x04)
	return 1;
	else 
	return 0;

}

void TP_auto_mode(void)
{	uchar temp;
  	LCD_CmdWrite(0x71);//TPCR1	
	temp = LCD_DataRead();
	temp &= cClrD6;
	LCD_CmdWrite(0x71);//TPCR1
	LCD_DataWrite(temp);
}

//==============================================================================
//Subroutine:	4wire or 5wire TP selection
//==============================================================================
void Set_4wire_TP(void)
{	uchar temp;
  	LCD_CmdWrite(0x71);//TPCR1	
	temp = LCD_DataRead();
	temp |= cSetD7;
//temp |= cSetD5;
	LCD_CmdWrite(0x71);//TPCR1
	LCD_DataWrite(temp);
}

/* ⲿж0ӳ */
void int0svr(void) interrupt 0 
{
	uchar temp=0x55;
	uint x,y;
uint tabx[4],taby[4];
uchar r;


EX0 = 0;		// رⲿж0
    
//PutString(0,0,0x12,"ж");
Show_String("touch",1); 
if(Touch_Status())
	{

 

    LCD_CmdWrite(0x72);//TPXH	 X_coordinate high byte
	Chk_Busy();
	temp=LCD_DataRead();
	
x=temp<<2;


	LCD_CmdWrite(0x73);//TPYH	  Y_coordinate high byte
	Chk_Busy();
	temp=LCD_DataRead();
	
y=temp<<2;	


LCD_CmdWrite(0x74);//TPYH	  Y_coordinate high byte
	Chk_Busy();
	temp=LCD_DataRead();
	
x=x+(temp&0x03);
y=y+(temp&0x0c);	


LCD_CmdWrite(0x8F);//INTC
  temp=LCD_DataRead(); 
  temp |= cSetD2;
  LCD_DataWrite(temp);

//Ϊֵʾ
    tabx[0]=x/1000;
	tabx[1]=x%1000/100;
	tabx[2]=x%100/10;
	tabx[3]=x%10;
	taby[0]=y/1000;
	taby[1]=y%1000/100;
	taby[2]=y%100/10;
	taby[3]=y%10;

//XY_Coordinate(0,0);
Show_String("x=",1); 
for(r=0;r<4;r++)	
		Show_Ascii(0x30+tabx[r]);
	
Show_String("y=",1); 
for(r=0;r<4;r++)	
		Show_Ascii(0x30+taby[r]);	
		
	}


	EX0 = 1;		// ⲿж0

}

//================== main process start ==================//
void main(void)
{


LCD_Reset(); // RA8870 

Delay100ms(1);
LCD_Initial(); // RA8870 ʼ
Delay100ms(1);

//---------TP initial ----
//	Set_4wire_TP();
Enable_TP();
LCD_CmdWrite(0x70);//set TP sample time  & ADC clock 
LCD_DataWrite(0xb2);
	Set_4wire_TP();
	TP_auto_mode(); //enable auto mode 
	//TP_manual_mode();
	enable_TP_interrupt();// demo code using Auto mode + polling 8Fh to confirm touch

/*
{
if(wait==0) PutString(0,70,0x12,"͵ƽ");
else ClearScreen();
}
*/


Active_Window(0,319,0,239); // 趨ֱΪ320*240 pixel

Memory_Clear_with_Font_BgColor(); // 趨ʾڴʱֱɫΪ
Text_Background_Color(0xfc); // 趨ֱɫΪɫ
Memory_Clear(); // ʾڴΪɫ
LCD_CmdWrite(0x01); // ʾ棨 Display on
LCD_DataWrite(0x80);
Text_Foreground_Color(0xe0); // 趨ɫɫ
Geometric_Coordinate(0,319,0,239); // 趨
LCD_CmdWrite(0x90);
LCD_DataWrite(0x90); // һο
Chk_Busy();
Text_Foreground_Color(0x1c); // 趨ɫɫ
Circle_Coordinate_Radius(160,120,100); // 趨Բ뾶
LCD_CmdWrite(0x90);
LCD_DataWrite(0x60); // һʵԲ
Chk_Busy();
Text_Foreground_Color(0x02); // 趨ɫɫ
Text_Mode();
XY_Coordinate(140,110); // 趨
LCD_CmdWrite(0x02);
Show_String("GP",1); //
IE=0x81;
IT0=1;
while(1);

}

