#ifndef OCM320240T350_H
#define OCM320240T350_H

#include "52-Driver.h"



void LCD_Reset(void);
void LCD_Initial(void);


void XY_Coordinate(uint X,uint Y);
void Normal_Mode_exitSleep(void);
void ShowBMP_256color(void);
void ShowBMP_4Kcolor(void);
void ShowBMP_64Kcolor(void);
void Show_String(uchar *str);
void Geometric_Coordinate(uint XL,uint XR ,uint YT ,uint YB);
void Circle_Coordinate_Radius(uint X,uint Y,uint R);
void Display_ON(void);
void Display_OFF(void);
void Sleep_Mode(void);
void Software_Reset(void);
void Digital_TFT(void);
void Analog_TFT(void);
void Parallel_Mode(void);
void Serial_Mode(void);
void No_ExternalMemory(void);
void ExternalMemory(void);
void ExternalMemory_8bitDataWidth(void);
void ExternalMemory_16bitDataWidth(void);
void Color_256(void);
void Color_4K(void);
void Color_64K(void);
void MPU_8bit_Interface(void);
void MPU_12bit_Interface(void);
void MPU_16bit_Interface(void);

void RGB_OddLines(void);
void RBG_OddLines(void);
void GRB_OddLines(void);
void GBR_OddLines(void);
void BRG_OddLines(void);
void BGR_OddLines(void);
void RGB_EvenLines(void);
void RBG_EvenLines(void);
void GRB_EvenLines(void);
void GBR_EvenLines(void);
void BRG_EvenLines(void);
void BGR_EvenLines(void);

void GPIO_Interface(void);
void AnalogTFT_Interface(void);
void OE_Input(void);
void OE_Output(void);
void One_Layer(void);
void Two_Layers(void);
void Disable_NoSnow_Mode(void);
void Enable_NoSnow_Mode(void);
void NoSnow_Mode0(void);
void NoSnow_Mode1(void);
void HDIR_SEG0_SEGn(void);
void HDIR_SEGn_SEG0(void);
void VDIR_COM0_COMn(void);
void VDIR_COMn_COM0(void);
void Rotate_0(void);
void Rotate_90(void);
void Rotate_180(void);
void Rotate_270(void);
void CGROM_Font(void);
void CGRAM_Font(void);
void CGRAM_HalfFont(void);
void CGRAM_FullFont(void);
void Internal_CGROM(void);
void External_CGROM(void);

void ASCII_Mode_enable(void);
void ASCII_Mode_disable(void);

void External_CGROM_GB(void);
void External_CGROM_BIG5(void);
void External_CGROM_Linear(void);

void ISO8859_1(void);
void ISO8859_2(void);
void ISO8859_3(void);
void ISO8859_4(void);

void No_FullAlignment(void);
void FullAlignment(void);
void Font_with_BackgroundColor(void);
void Font_with_BackgroundTransparency(void);
void NoBold_Font(void);
void Bold_Font(void);
void NoRotate_Font(void);
void Rotate90_Font(void);
void Horizontal_FontEnlarge_x1(void);
void Horizontal_FontEnlarge_x2(void);
void Horizontal_FontEnlarge_x3(void);
void Horizontal_FontEnlarge_x4(void);
void Vertical_FontEnlarge_x1(void);
void Vertical_FontEnlarge_x2(void);
void Vertical_FontEnlarge_x3(void);
void Vertical_FontEnlarge_x4(void);
void Scroll_Offset(uint X,uint Y);
void Line_distance(uchar x);
void Active_Window(uint XL,uint XR ,uint YT ,uint YB);
void Scroll_Window(uint XL,uint XR ,uint YT ,uint YB);
void Graphic_Mode(void);
void Text_Mode(void);
void No_TextCursor(void);
void Text_Cursor(void);
void Text_Blink_Time(uchar x);
void No_TextCursorBlink(void);
void TextCursorBlink(void);
void LeftRight_TopDown(void);
void RightLeft_TopDown(void);
void TopDown_LeftRight(void);
void DownTop_LeftRight(void);
void MemoryWrite_Cursor_autoIncrease(void);
void MemoryWrite_Cursor_NoautoIncrease(void);
void MemoryRead_Cursor_autoIncrease(void);
void MemoryRead_Cursor_NoautoIncrease(void);
void No_Graphic_Cursor(void);
void Graphic_Cursor(void);
void Graphic_Cursor_HDIR_Pic(void);
void Graphic_Cursor_Set1(void);
void Graphic_Cursor_Set2(void);
void Graphic_Cursor_Set3(void);
void Graphic_Cursor_Set4(void);
void Graphic_Cursor_Set5(void);
void Graphic_Cursor_Set6(void);
void Graphic_Cursor_Set7(void);
void Graphic_Cursor_Set8(void);
void Write_To_Bank1and2(void);
void Write_To_CGRAM(void);
void Write_To_GraphicCursor(void);
void Write_To_Pattern(void);
void Write_To_Bank1(void);
void Write_To_Bank2(void);
void Text_Foreground_Color(uchar color);
void Text_Background_Color(uchar color);
void Text_Cursor_Size(uchar size);
void Graphic_Cursor_Coordinate(uint X,uint Y);
void Graphic_Cursor_Color(uint color);
void Layer1_Visible(void);
void Layer2_Visible(void);
void Transparent_Mode(void);
void Lighten_Overlay_Mode(void);
void Boolean_OR(void);
void Boolean_AND(void);

void Layer1_2_scroll(void);
void Layer1_scroll(void);
void Layer2_scroll(void);

void layer2_1_transparency(uchar temp);

void BackgroundColor_TransparentMode(uint color);

void PWM1_enable(void);//add by mountain 
void PWM1_disable(void);
void PWM1_disable_level_low(void);
void PWM1_disable_level_high(void);

void PWM1_fnuction_sel(void); //add by mountain 
void PWM1_clock_ratio(uchar divide); //bit0~3 
void PWM1_duty_cycle(uchar setx); //bit0~7

void PWM2_enable(void);//add by mountain 
void PWM2_disable(void);
void PWM2_disable_level_low(void);
void PWM2_disable_level_high(void);
void PWM2_fnuction_sel(void); //add by mountain 
void PWM2_clock_ratio(uchar divide); //bit0~3 
void PWM2_duty_cycle(uchar setx); //bit0~7


void No_Memory_Clear(void);
void Memory_Clear(void);
void Clear_Full_Window(void);
void Clear_Active_Window(void);
void Memory_Clear_Bank1(void);
void Memory_Clear_Bank2(void);
void Memory_Clear_with_BTE_BgColor(void);
void Memory_Clear_with_Font_BgColor(void);


void BTE_Interrupt_enable(void);
void BTE_Interrupt_disable(void);
bit BTE_interrupt_status(void);
void BTE_Interrupt_clear(void);

void CGRAM_Select_Number(number);
void Nazi_symbol(void);
void no_BTE_write(void);
void BTE_enable(void);
void BTE_contiguous_Data(void);
void BTE_rectangular_Data(void);
void BTE_ROP_Code(CODE);
void BTE_Source_Destination	(uint SX,uint DX ,uint SY ,uint DY);
void BTE_Size_setting(width,height);
void BTE_Foreground_red(uint color);
void BTE_Foreground_green(uint color);
void BTE_Foreground_blue(uint color);  
void BTE_Background_red(uint color);
void BTE_Background_green(uint color);
void BTE_Background_blue(uint color);
void Pattern_Set_number(number);
void Graphic_Cursor_Color_0(uint color);
void Graphic_Cursor_Color_1(uint color);
void Print_Hex(uchar buf);
void Source_Layer1(void);
void Source_Layer2(void);
void Destination_Layer1(void);
void Destination_Layer2(void);
void CheckerBoard_layer1(void);
void CheckerBoard_layer2(void);
void No_Font_Write_Interrupt(void);
void Font_Write_Interrupt(void);
void No_Clear_Font_Write_Interrupt(void);
void Clear_Font_Write_Interrupt(void);	  
void Print_ABCD(void);
void ShowBMP_4Kcolor_1(void);
void Memory_read_Coordinate(uint X,uint Y);
void Memory_read_LeftRight_TopDown(void);
void Memory_read_RightLeft_TopDown(void);
void Memory_read_TopDown_LeftRight(void);
void Memory_read_DownTop_LeftRight(void);
void Analog_Color_Bar(void);
void Pic_monochrom_to_color(void);
void Chk_Busy_BTE(void);
void sun_shape(void);
void moon_shape(void);
void Effiel_DayView(void);
void Effiel_NightView(void);
void Blue_Sky(void);
void SunSet_SunRise(void);
void Graphic_Cursor_Pic(void);
void exit_sleep_by_TP(void);
void BTE_interrupt_Verify(void); 
void Demo_Display_Page_Switch(char Page_Num);


void Draw_line(void);
void Draw_square(void);
void Draw_square_fill(void);
void Draw_circle(void);
void Draw_circle_fill(void);


//TP
void Enable_TP(void);
void Disable_TP(void);
void Enable_Touch_WakeUp(void);
void Disable_Touch_WakeUp(void);
void Set_4wire_TP(void);
void Set_5wire_TP(void);
void TP_manual_mode(void);
void TP_auto_mode(void);
void TP_IDLE_mode(void);
void TP_event_mode(void);
void TP_latch_X(void);
void TP_latch_Y(void);
uchar ADC_X(void);
uchar ADC_Y(void);
uchar ADC_XY(void);
bit Touch_Status(void);
void clear_TP_interrupt(void);
void enable_TP_interrupt(void);
void disable_TP_interrupt(void);

#endif